*! version: 1.0.0 07aug2001

program define _resamplecheck, sclass
	version 7
	args caller cmd nowarn
	if `"`nowarn'"'!="nowarn" {
		local nowarn warn
	}
	cap est hold __j_resample
	cap `cmd'
	/* let the caller handle any errors */
	if ! _rc {
		if `"`e(cmd)'"' == "" { /* cmd is not eclass */
			`nowarn' "`caller'" "`cmd'"
		}
		else { /* check for unused observations */
			cap assert e(sample)==1
			if _rc {
				cap assert e(sample)==0
				if _rc {
/***				caller should preserve then keep if e(sample) */
					sret local needpreserve yes
					cap est drop __j_resample
				}
				else {
					`nowarn' "`caller'" "`cmd'"
				}
			}
		}
	}
	cap est unhold __j_resample
end

program define nowarn
	version 7
end

program define warn
	version 7
	args caller command

	gettoken cmd : command
  di in smcl as txt ""
  di `"{p 0 10} Warning:  Since {cmd:`cmd'} is not an estimation command "' _c
  di `"or does not set {cmd:e(sample)}, "' _c
  di `"{cmd:`caller'} has no way to determine which observations are used "' _c
  di `"in calculating the statistics and so assumes that all observations "' _c
  di `"are used.  This means no observations will be excluded from the "' _c
  di `"resampling due to missing values or other reasons."' _n

  di `"{p 10 10} If the assumption is not true, press Break, save the "' _c
  di `"data, and drop the observations that are to be excluded. "'
  di `"Be sure the dataset in memory contains only the relevant data."' _n

end

exit

------------------------------------------------------------------------------
NOTES
------------------------------------------------------------------------------

This command is to be used with resampling routines that accept Stata
commands.  The problem here is that there may be some missing values in a
variable in the model, thus the actual number of data observations is not
equal to the number of observations used in estimation.

Saved Results:

-_resamplecheck- is an -sclass- command:

Macros:

  s(needpreserve)     "yes" or ""

When -s(needpreserve)- is "yes", the caller should do the following before
it starts resampling.

     . preserve
     . keep if e(sample)

<end>

