*!version 6.2.0  20feb2002
program define _stcurv, rclass
	version 6
	if "`e(cmd2)'" != "streg" & "`e(cmd2)'"!= "stcox"{ 
		error 301
	}
        syntax [, CUMHaz SURvival HAZard  UNCONDitional ALPHA1 /*
		*/ save(string) by(string) /*
		*/ Range(numlist ascending min=2 max=2 ) L2title(string)/*
		*/ AT(string) TItle(string) B1title(string) B2title(string) * ]

	local n = ("`cumhaz'"!="") + ("`surviva'"!="") + ("`hazard'"!="")

	if "`by'"~="" {
		noi di in red "by() option not alllowed"
		exit 198
	}	

	if `n'==0 { 
		di in red /*
	   	*/ "must specify one of the options cumhaz, survival, or hazard"
		exit 198
	}
	if `n'>1 { 
		di in red /*
		*/ "must specify only one of cumhaz, survival, and hazard"
		exit 198
	}

	if "`e(cmd)'" != "weibull" &  "`e(cmd)'" != "ereg" /*
	*/ & "`e(cmd)'" != "lnormal" & "`e(cmd)'" != "llogistic" /*
	*/ & "`e(cmd)'" != "gompertz" & "`e(cmd)'" != "gamma" & /*
	*/ "`e(cmd)'" != "cox" & /*
	*/ "`e(cmd)'" != "weibullhet" &  "`e(cmd)'" != "ereghet" /*
	*/ & "`e(cmd)'" != "lnormalhet" & "`e(cmd)'" != "llogistichet" /*
	*/ & "`e(cmd)'" != "gompertzhet" & "`e(cmd)'" != "gammahet" {
		di in red /*
		*/ "stcurve cannot yet graph using the `e(cmd)' distribution"
		exit 301
	}
	if "`e(stcurve)'"=="" & `"`e(frailty)'"'=="" & "`e(cmd)'" != "cox" {
		di in red /*
		*/ "stcurve cannot graph the `e(cmd)' distribution" 
		di in red "when ancillary() or strata() options are specified"
		exit 301
	}
	else local model="`e(cmd)'"
	if "`model'"=="cox" & "`range'"~="" {
		di in red "range() option not valid after Cox regression"
		exit 198
	}

	if "`range'"!="" {
		local begin: word 1 of `range'
		local end  : word 2 of `range'
		local bopt="begin(`begin')"
		local eopt="end(`end')"
	}

	preserve
	qui keep if e(sample)
	if "`at'"!="" {
		mat B=e(b)
		tokenize "`at'" ,parse(" =,")
		while "`1'"!="" {
			confirm var `1'
			confirm number `3'
			CheckVar `1' `B'
			if "`by'"=="`1'" {
				noi di in red /*
				*/ "by() and at() cannot share variables"
				exit 198
			}
			qui replace `1' `2' `3'
			if "`4'"=="," {
				mac shift 4
			}
			else { mac shift 3 }
		}
	}
	tempname nff nt
	if "`model'"== "weibull" | "`model'"== "weibullhet" { 
		WeiPlot `nff' `nt', /* 
			*/ `cumhaz' `survival' `hazard' `bopt' `eopt' /*
			*/ `uncondi' `alpha1'
        	local bb "Weibull regression"
	}
	if "`model'"== "ereg"  | "`model'"== "ereghet" { 
		ExpPlot `nff' `nt', /* 
			*/ `cumhaz' `survival' `hazard' `bopt' `eopt' /*
			*/ `uncondi' `alpha1'
        	local bb "Exponential regression"
	}
	if "`model'"== "lnormal" | "`model'"=="lnormalhet" { 
		LnoPlot `nff' `nt', /* 
			*/ `cumhaz' `survival' `hazard' `bopt' `eopt' /*
			*/ `uncondi' `alpha1'
        	local bb "Log-normal regression"
	}
	if "`model'"== "llogistic" | "`model'"== "llogistichet" { 
		LloPlot `nff' `nt', /*
			*/ `cumhaz' `survival' `hazard' `bopt' `eopt' /*
			*/ `uncondi' `alpha1'
        	local bb "Log-logistic regression"
	}
	if "`model'"== "gompertz"  | "`model'"== "gompertzhet" { 
		GomPlot `nff' `nt', /* 
			*/ `cumhaz' `survival' `hazard' `bopt' `eopt' /*
			*/ `uncondi' `alpha1'
        	local bb "Gompertz regression"
	}
	if "`model'"== "gamma"  | "`model'"== "gammahet" { 
		GamPlot `nff' `nt', /* 
			*/ `cumhaz' `survival' `hazard' `bopt' `eopt' /*
			*/ `uncondi' `alpha1'
        	local bb "Generalized gamma regression"
	}
	if "`model'"== "cox"  { 
		if "`e(bases)'"==""{
			di in red /* 
			*/"must specify basesurv() option in stcox"
			exit 198
		}
		if "`hazard'"!="" {
			di in red /*
			*/"hazard not allowed with Cox model"
			exit 198
		}
		CoxPlot `nff' `nt', `cumhaz' `survival'
        	local bb "Cox proportional hazards regression"
	}
	label var `nt' "`e(depvar)'"
	if `"`title'"' != "" {
		local bb `"`title'"'
	}
	qui save `"`save'"', replace
	*graph `nff' `bynff' `nt',  `l2opt' `options' sort
	ret local myvars = "`nff' `bynff' `nt'"
	ret local bb=`"`bb'"'
	ret local l2opt=`"`l2opt'"'
end	

prog def CheckVar 
	args varn B
	unab myvarn: `varn'
	local bnames: colnames B 
	local bsize: word count `bnames'
	tokenize `bnames'
	local flag 0
	local i 1
	while `i'<=`bsize' {
		if "`myvarn'"=="`1'" {
			local flag=1
		}
		mac shift
		local i=`i'+1		
	}
	if `flag'==0 {
		noi di in red /*
		*/ "at() variable `myvarn' not in the estimated model"
		exit 198
	}
end

program define WeiPlot 
	syntax newvarlist(gen min=2 max=2) [, CUMHaz SURvival HAZard /*
		*/ UNCONDitional ALPHA1 /*
		*/ Begin(string) End(string) ]
	tokenize `varlist'
	local nff "`1'"
	local nt "`2'"
	local t:   char _dta[st_t]
       	local wtopt:  char _dta[st_w]  
	tempname b  
       	tempvar  flag
	mat `b'= get(_b)
	if  e(cmd) == "weibullhet" {
		local k=colsof(`b')-2
	}
	else {
		local k=colsof(`b')-1
	}
	local N=_N+1
	qui set obs `N'
	qui gen `flag'=1 if _n==_N
	local rhs: colnames(`b')
	tokenize "`rhs'"
	local i 1
	while `i'<=`k'-1 {
		sum `1' `wtopt' , meanonly
		qui replace `1'=r(mean) 
		mac shift
		local i=`i'+1
	}
	if "`end'"!="" {
		qui keep if `flag'==1
		qui expand 102
		qui replace `t'=`begin' in 1
		local int=(`end'-`begin')/100
		qui replace `t'=`t'[_n-1]+`int' if _n>1
		qui replace `flag'=0 if _n!=_N
	}

	qui replace _st=1
	qui replace _t0=1

  	if "`cumhaz'"!="" {
		tempvar  ff
		qui predict double `ff', surv `alpha1' `uncondi'
		qui replace `ff'=-log(`ff')
		label var `ff' "Cumulative Hazard"
		qui drop if `flag'==1
	}
  	if "`hazard'"!="" {
		tempvar ff
		qui predict double `ff', haz `alpha1' `uncondi'
		label var `ff' "Hazard function"
		qui drop if `flag'==1
		
	}
  	if "`survival'"!="" {
		tempvar ff
		qui predict double `ff', surv `alpha1' `uncondi'
		label var `ff' "Survival"
		qui drop if `flag'==1
	}
	qui replace `nff'= `ff'
	qui replace `nt'= `t'
	local ffl: variable label `ff'
	local ntl: variable label `t'
	label var `nff' "`ffl'"
	label var `nt' "`ntl'"
 
end
program define ExpPlot 
	syntax newvarlist(gen min=2 max=2) [, CUMHaz SURvival HAZard /*
		*/ UNCONDitional ALPHA1 /*
		*/ Begin(string) End(string) ]
	tokenize `varlist'
	local nff "`1'"
        local nt "`2'"
	local t:   char _dta[st_t]
       	local wtopt:  char _dta[st_w]  
	tempname b 
	tempvar flag
	mat `b'= get(_b)
	if  e(cmd) == "ereghet" {
		local k=colsof(`b')-1
	}
	else {
		local k=colsof(`b')
	}
	local N=_N+1
	qui set obs `N'
	qui gen `flag'=1 if _n==_N
	local rhs: colnames(`b')
	tokenize "`rhs'"
	local i 1
	while `i'<=`k'-1 {
	        sum `1' `wtopt', meanonly
	        qui replace `1'=r(mean) 
	        mac shift
	        local i=`i'+1
	}
	if "`end'"!="" {
		qui keep if `flag'==1
		qui expand 102
		qui replace `t'=`begin' in 1
		local int=(`end'-`begin')/100
		qui replace `t'=`t'[_n-1]+`int' if _n>1
		qui replace `flag'=0 if _n!=_N
	}

	qui replace _st=1
	qui replace _t0=0
	if "`cumhaz'"!="" {
	        tempvar  ff
		qui predict double `ff', surv `alpha1' `uncondi'
		qui replace `ff'=-log(`ff')
		label var `ff' "Cumulative Hazard"
	        qui drop if `flag'==1
	}
	if "`hazard'"!="" {
	        tempvar ff
		qui predict double `ff', haz `alpha1' `uncondi'
	        label var `ff' "Hazard function"
	        qui drop if `flag'==1
	}
	if "`survival'"!="" {
	        tempvar ff
		qui predict double `ff', surv `alpha1' `uncondi'
		label var `ff' "Survival"
		qui drop if `flag'==1
	}
	qui replace `nff'= `ff'
	qui replace `nt'= `t'
	local ffl: variable label `ff'
	local ntl: variable label `t'
	label var `nff' "`ffl'"
	label var `nt' "`ntl'"
end


program define LnoPlot
	syntax newvarlist(gen min=2 max=2) [, CUMHaz SURvival HAZard /*
		*/ UNCONDitional ALPHA1 /*
		*/ Begin(string) End(string) ]
	tokenize `varlist'
        local nff "`1'"
        local nt "`2'"

        local t:   char _dta[st_t]
        local wtopt:  char _dta[st_w]

	tempname b
	tempvar  flag
	mat `b'= get(_b)
	if  e(cmd) == "lnormalhet" {
		local k=colsof(`b')-2
	}
	else {
		local k=colsof(`b')-1
	}

	local N=_N+1
	qui gen `flag'=1 if _n==_N
	qui set obs `N'
	local rhs: colnames(`b')
	tokenize "`rhs'"
	local i 1
	while `i'<=`k'-1 {
	        sum `1' `wtopt' , meanonly
	        qui replace `1'=r(mean)
	        mac shift
	        local i=`i'+1
	}
	if "`end'"!="" {
		qui keep if `flag'==1
		qui expand 102
		qui replace `t'=`begin' in 1
		local int=(`end'-`begin')/100
		qui replace `t'=`t'[_n-1]+`int' if _n>1
		qui replace `flag'=0 if _n!=_N
	}
	qui replace _st=1
	qui replace _t0=0
	if "`cumhaz'"!="" {
	        tempvar  ff
		qui predict double `ff', surv `alpha1' `uncondi'
		qui replace `ff'=-ln(`ff')
	        label var `ff' "Cumulative Hazard"
	        qui drop if `flag'==1
	}

	 if "`hazard'"!="" {
	        tempvar ff
		qui predict double `ff', haz `alpha1' `uncondi'
	        label var `ff' "Hazard function"
	        qui drop if `flag'==1
	}
	if "`survival'"!="" {
	        tempvar  ff
		qui predict double `ff', surv `alpha1' `uncondi'
	        label var `ff' "Survival"
	        qui drop if `flag'==1
	}
	qui replace `nff'= `ff'
	qui replace `nt'= `t'
	local ffl: variable label `ff'
	local ntl: variable label `t'
	label var `nff' "`ffl'"
	label var `nt' "`ntl'"
end

program define LloPlot
	syntax newvarlist(gen min=2 max=2) [, /*
		*/ UNCONDitional ALPHA1 /*
        	*/ CUMHaz SURvival HAZard Begin(string) End(string) ]
	tokenize `varlist'
	local nff "`1'"
	local nt "`2'"

	local t:   char _dta[st_t]
	local wtopt:  char _dta[st_w]

	tempname b
	tempvar  flag
	mat `b'= get(_b)
	if  e(cmd) == "llogistichet" {
		local k=colsof(`b')-2
	}
	else {
		local k=colsof(`b')-1
	}

	local N=_N+1
	qui set obs `N'
	qui gen `flag'=1 if _n==_N
	local rhs: colnames(`b')
	tokenize "`rhs'"
	local i 1
	while `i'<=`k'-1 {
		sum `1' `wtopt' , meanonly
		qui replace `1'=r(mean)
		mac shift
		local i=`i'+1
	}
	if "`end'"!="" {
		qui keep if `flag'==1
		qui expand 102
		qui replace `t'=`begin' in 1
		local int=(`end'-`begin')/100
		qui replace `t'=`t'[_n-1]+`int' if _n>1
		qui replace `flag'=0 if _n!=_N
	}
	qui replace _st=1
	qui replace _t0=0

	if "`cumhaz'"!="" {
		tempvar  ff
		qui predict double `ff', surv `alpha1' `uncondi'
		qui replace `ff'=-ln(`ff')
		label var `ff' "Cumulative Hazard"
		qui drop if `flag'==1
	}
	if "`hazard'"!="" {
		tempvar ff
		qui predict double `ff', haz `alpha1' `uncondi'
		label var `ff' "Hazard function"
		qui drop if `flag'==1
	}
	if "`survival'"!="" {
		tempvar  ff
		qui predict double `ff', surv `alpha1' `uncondi'
		label var `ff' "Survival"
		qui drop if `flag'==1
	}
	qui replace `nff'= `ff'
	qui replace `nt'= `t'
	local ffl: variable label `ff'
	local ntl: variable label `t'
	label var `nff' "`ffl'"
	label var `nt' "`ntl'"

end


program define GomPlot
	syntax newvarlist(gen min=2 max=2) [, /*
		*/ UNCONDitional ALPHA1 /*
		*/ CUMHaz SURvival HAZard Begin(string) End(string) ]
	tokenize `varlist'
	local nff "`1'"
	local nt "`2'"

	local t:   char _dta[st_t]
	local wtopt:  char _dta[st_w]

	tempname b  
	tempvar  flag
	mat `b'= get(_b)
	if  e(cmd) == "gompertzhet" {
		local k=colsof(`b')-2
	}
	else {
		local k=colsof(`b')-1
	}
	local N=_N+1
	qui set obs `N'
	qui gen `flag'=1 if _n==_N
	local rhs: colnames(`b')
	tokenize "`rhs'"
	local i 1
	while `i'<=`k'-1 {
	        sum `1' `wtopt' , meanonly
	        qui replace `1'=r(mean)
	        mac shift
	        local i=`i'+1
	}
	if "`end'"!="" {
		qui keep if `flag'==1
		qui expand 102
		qui replace `t'=`begin' in 1
		local int=(`end'-`begin')/100
		qui replace `t'=`t'[_n-1]+`int' if _n>1
		qui replace `flag'=0 if _n!=_N
	}
	qui replace _st=1
	qui replace _t0=0

	if "`cumhaz'"!="" {
	        tempvar  ff
		qui predict double `ff', surv `alpha1' `uncondi'
		qui replace `ff'=-ln(`ff')
	        label var `ff' "Cumulative Hazard"
	        qui drop if `flag'==1
	}
	if "`hazard'"!="" {
       		tempvar ff
		qui predict double `ff', haz `alpha1' `uncondi'
        	label var `ff' "Hazard function"
		qui drop if `flag'==1
	}
	if "`survival'"!="" {
        	tempvar ff
		qui predict double `ff', surv `alpha1' `uncondi'
	        label var `ff' "Survival"
	        qui drop if `flag'==1
	}

	qui replace `nff'= `ff'
	qui replace `nt'= `t'
	local ffl: variable label `ff'
	local ntl: variable label `t'
	label var `nff' "`ffl'"
	label var `nt' "`ntl'"

end

program define GamPlot
	syntax newvarlist(gen min=2 max=2) [, /*
		*/ UNCONDitional ALPHA1 /*
		*/ CUMHaz SURvival HAZard Begin(string) End(string) ]
	tokenize `varlist'
	local nff "`1'"
	local nt "`2'"

	local t:   char _dta[st_t]
	local wtopt:  char _dta[st_w]


	tempname b 
	tempvar flag
	mat `b'= get(_b)
	if  e(cmd) == "gammahet" {
		local b0=colsof(`b')-3
	}
	else {
		local b0=colsof(`b')-2
	}

	local bb "Gamma regression"
	local N=_N+1
	qui set obs `N'
	qui gen `flag'=1 if _n==_N
	local rhs: colnames(`b')
	tokenize "`rhs'"
	local i 1
	while `i'<=`b0'-1 {
		sum `1' `wtopt' , meanonly 
		qui replace `1'=r(mean) 
		mac shift
		local i=`i'+1
	}
	if "`end'"!="" {
		qui keep if `flag'==1
		qui expand 102
		qui replace `t'=`begin' in 1
		local int=(`end'-`begin')/100
		qui replace `t'=`t'[_n-1]+`int' if _n>1
		qui replace `flag'=0 if _n!=_N
	}
	qui replace _st=1
	qui replace _t0=0

	if "`cumhaz'"!="" {
	        tempvar  ff
		qui predict double `ff', surv `alpha1' `uncondi'
		qui replace `ff'=-ln(`ff')
		label var `ff' "Cumulative Hazard"
		qui drop if `flag'==1
	}
	if "`hazard'"!="" {
		tempvar ff
		qui predict double `ff', haz `alpha1' `uncondi'
		label var `ff' "Hazard function"
		qui drop if `flag'==1
	}
	if "`survival'"!="" {
		tempvar  ff
		qui predict double `ff', surv `alpha1' `uncondi'
		label var `ff' "Survival"
		qui drop if `flag'==1
	}
	qui replace `nff'= `ff'
	qui replace `nt'= `t'
	local ffl: variable label `ff'
	local ntl: variable label `t'
	label var `nff' "`ffl'"
	label var `nt' "`ntl'"

end
program define CoxPlot
	syntax newvarlist(gen min=2 max=2) [, /*
		*/ CUMHaz SURvival Begin(string) End(string) ]
	tokenize `varlist'
	local nff "`1'"
	local nt "`2'"

	local t:   char _dta[st_t]
	local wtopt:  char _dta[st_w]
	

	tempname b 
	tempvar flag 
	mat `b'= get(_b)
	local b0=colsof(`b')

	local bb "Cox regression"
	local N=_N+1
	qui set obs `N'
	qui gen `flag'=1 if _n==_N
	local rhs: colnames(`b')
	tokenize "`rhs'"
	local i 1
	while `i'<=`b0' {
		sum `1' `wtopt' , meanonly 
		qui replace `1'=r(mean) 
		mac shift
		local i=`i'+1
	}
	if "`end'"!="" {
		qui keep if `flag'==1
		qui expand 102
		qui replace `t'=`begin' in 1
		local int=(`end'-`begin')/100
		qui replace `t'=`t'[_n-1]+`int' if _n>1
		qui replace `flag'=0 if _n!=_N
	}
	qui replace _st=1
	qui replace _t0=0

	if "`cumhaz'"!="" {
	        tempvar  ff
		qui predict double `ff', xb
                qui replace `ff'=`e(bases)'^exp(`ff')
		qui replace `ff'=-ln(`ff')
		label var `ff' "Cumulative Hazard"
		qui drop if `flag'==1
	}
/* rgg
	if "`hazard'"!="" {
		tempvar ff
		qui predict double `ff', xb
		qui replace `ff'=`e(baseh)'*exp(`ff')
		label var `ff' "Hazard function"
		qui drop if `flag'==1
	}
*/
	if "`survival'"!="" {
		tempvar  ff
		qui predict double `ff', xb
		qui replace `ff'=`e(bases)'^exp(`ff')
		label var `ff' "Survival"
		qui drop if `flag'==1
	}
	qui replace `nff'= `ff'
	qui replace `nt'= `t'
	local ffl: variable label `ff'
	local ntl: variable label `t'
	label var `nff' "`ffl'"
	label var `nt' "`ntl'"
end
