*! version 7.1.6  12jul2001
program define binreg, eclass byable(recall)
	version 7.0
	if replay() {
		if _by() { error 190 }
		syntax, [ Level(integer $S_level) ]
		local efopt= `"`e(eform)'"'
		Playback ,level(`level') `efopt'
		exit
	}

	syntax varlist [if] [in] [fw aw pw iw] [, OR RR RD HR COEFF /*
		*/ ML N(string) cmd Level(integer $S_level) INIt(varname) * ]

	if `"`weight'"'!="" {
			local wtopt="[`weight' `exp']"
	}
	if "`ml'"=="" {
		local metopt="irls"
	}
	if "`init'"!="" {
		local mu "mu(`init')"
	}

	local nc : word count `or' `rr' `rd' `hr'
	if `nc' > 1 {
		di as err "may choose only one of or, rr, rd, hr options"
		exit 198
	}
	local eopt 0 
	if `nc' != 0 & "`coeff'" == "" { local eopt 1 } 
	if `nc' == 0 { 
		local or "or"
	}
	if "`rd'" != "" {
		if "`coeff'" == "" { local eopt 0 }
		else               { local eopt 1 } 
	}

	marksample touse 		/* must be done early */

	if "`n'" == ""			{ local m 1		}
	else				{ local m `"`n'"'	}
	capture confirm variable `m'
        if _rc~=0 {
		capture confirm integer number `m'
		if _rc~=0 {
			noi di as err /*
		*/ "option n(`m') invalid - integer or variable name expected"
		exit 198
		}
	}

        capture confirm integer number `m'
        local mfixed = (_rc==0)         /* Fixed if not a variable */


	local famopt="family(binomial `m')"

	if "`or'" != ""		{ 
		local link "logit"			/* logistic	*/
		local efopt "eform(Odds Ratio)"
		local cmsg  "Odds ratio coefficients"
	}
	else if "`rr'" != ""	{ 
		local link "log"			/* log		*/
		local efopt "eform(Risk Ratio)"
		local cmsg  "Risk ratio coefficients"
	}
	else if "`rd'" != ""	{ 
		local link "identity"			/* identity	*/
		/* local efopt "eform(Risk Diff.)" */
		local cmsg  "Risk difference coefficients"
	}
	else if "`hr'" != ""	{ 
		local link "logc"			/* log compl.	*/
		local efopt "eform(HR)"
		local cmsg  "Health ratio coefficients"
		if "`coeff'"=="" {
			local cmsg  "Health ratio (HR)"
		}
	}
	if !`eopt' { local efopt }

	local bernoul = `mfixed' & `"`m'"'=="1"         /* Bernoulli dist */

	
	if `"`cmd'"'!="" {
                di _n as txt "-> glm `varlist' `if' `in' `wtopt', " _c
		di as txt "`metopt' link(`link') family(binomial `m')" _c
		di as txt " level(`level') `mu' `options'" _c
                exit
        }


	glm `varlist' `if' `in' `wtopt', nodisplay /*
	*/  `metopt' link(`link') family(binomial `m') `mu' /* 
	*/   level(`level') `options'
	*  link(`link') family(binomial `m') level(`level') `options'


	if `"`e(offset)'"'!="" {
		local offopt `", offset `e(offset)'"'
	}

	DescFL "binomial" `"`link'"' `bernoul' `m'
        local o `"`r(dist)', `r(link)'`offopt'"'
        local lll : word 1 of `r(link)'
	est local cmd "binreg"
	est local  title_fl `"`o'"'
	est local  eform `"`efopt'"'
	
	if `"`e(msg)'"'!="" {
		est local msg_1 `"(Standard errors scaled using `e(msg)')"'
	}
	if "`e(disp)'"~="" & "`e(disp)'"!="1" {
		est local msg_2 /*
	*/ `"(Quasi-likelihood model with dispersion `e(disp)')"'
	}
	if !`eopt' {
		est local msg_3 `"`cmsg'"'
	}
	if "`hr'"~="" {
		est local msg_3 `"`cmsg'"'
	}

	Playback, level(`level') `efopt'
end


program define Playback
	syntax [, LEvel(int $S_level) EForm(passthru)]
	if `"`e(cmd)'"'!="binreg" { error 301 } 

	if `level'<10 | `level'>99 { 
		di as err "level() must be between 10 and 99"
		exit 198
	}
	#delimit ;
	di _n as txt "Residual df  = " as res %9.0g e(df)
		_col(57) as txt "No. of obs = "  as res %9.0g e(N) ;
	di as txt "Pearson X2   = " as res %9.0g e(deviance_p) as txt 
		_col(57) "Deviance   = "  as res %9.0g e(deviance) ;
	di as txt "Dispersion   = " as res %9.0g e(dispers_p) as txt
		_col(57) "Dispersion = "  as res %9.0g e(dispers) ;
	#delimit cr

	di as txt _n `"`e(title_fl)'"' /* family, link, offset */
	if `"`e(msg_3)'"' != "" {
		di as txt "`e(msg_3)'"
	}
	est di, level(`level') `eform'
	local i 1
	while `i' <= 2 {
		if `"`e(msg_`i')'"' != "" { di as txt `"`e(msg_`i')'"' }
		local i = `i' + 1
	}
	error `e(rc)'
end


program define DescFL, rclass /* return description of family and link */
	args f l bernoul m

	local s1 " distribution"
	local s2 " link"

	if `bernoul'	{ local s1 `"Bernoulli`s1'"' }
	else 		{ local s1 `"Binomial (N=`m')`s1'"' }

	if `"`l'"'=="logit"		{ local s2 `"logit`s2'"' }
	else if `"`l'"'=="log"	{ local s2 `"log`s2'"' }
	else if `"`l'"'=="logc"	{ local s2 `"log-complement`s2'"' }
	else if `"`l'"'=="identity"	{ local s2 `"identity`s2'"' }

	ret local dist `"`s1'"'
	ret local link `"`s2'"'
end
exit
Notes:
	This program fits the model described in:

	Wacholoder, Sholom 1986.
		Binomial regression in GLIM: estimating 
		risk ratios and risk differences
		American Journal of Epidemiology, 123:174--184.

James Hardin and Mario Cleves
Email correspondence to: mcleves@@stata.com
