*! version 3.2.6  28may2002
program define blogit, eclass byable(recall)
	version 6
	local options "Level(integer $S_level) or"
	if replay() {
		if "`e(cmd)'"!="blogit" { error 301 }
		if _by() { error 190 }
		syntax [, `options']
		logit, level(`level') `or'
		exit
	}
	syntax varlist(min=2) [if] [in] [, CLuster(varname) /*
		*/ OFFset(varname) `options' LOg *]
	marksample touse

	qui count if `touse'
	if r(N)==0 { error 2000 } 

	if `level'<10 | `level'>99 { local level 95 } 
	if "`log'"=="" { local log "nolog" } 

	if "`offset'" ~= "" { local offopt "offset(`offset')" }
	if "`cluster'"~= "" { local clopt "cluster(`cluster')" }

	preserve 
	quietly { 
		keep if `touse'
		keep `varlist' `cluster' `offset'
		confirm new var _outcome
		tokenize `varlist'
		local lhs "`1' `2'"

		local k = _N
		local k1 = _N + 1
		expand =2, clear

		tempvar pop
		gen byte _outcome=0 in 1/`k'
		replace _outcome=1 in `k1'/l
		gen `pop'=`2'-`1' in 1/`k'
		replace `pop'=`1' in `k1'/l
		mac shift 2
	}
	logit _outcome `*' [freq=`pop'], level(`level') `or' /*
		*/ `options' `log' `clopt' `offopt'

	/* the e() stuff is inherited from -logit- except e(cmd) */
	/* double save in S_E_<stuff> and e() */
	est local cmd
	est local wexp
	est local wtype
	est local depvar "`lhs'"
	est local predict "glogit_p"

	global S_E_nobs = e(N)
	global S_E_ll = e(ll)
	global S_E_mdf = e(df_m)
	global S_E_cmd "blogit"
	restore
	est repost, esample(`touse')
	est local cmd "blogit"
end
