*! version 1.0.7  06aug2001
program define bs
	version 6
	local version : di "version " _caller() ":"
	gettoken cmd   0: 0
	gettoken stats 0: 0

	if `"`cmd'"'==`""' { error 198 }
	if `"`stats'"'==`""' {
		di in red `"list of statistics not found"'
		exit 111
	}
	tokenize `"`stats'"'

/* Display command and list of statistics. */

	di in gr _n `"command:     `cmd'"'

	if `"`2'"'==`""' { di in gr `"statistic:   `stats'"' }
	else	           di in gr `"statistics:  `stats'"'

/* Run command to see if it runs without error. */

	capture `version' `cmd'
	if _rc {
		if _rc==1 { error 1 }
		di in red `"error when command executed on original dataset"'
		error _rc
	}

/* Check list of statistics. */

	tempname x
	local stats /* erase macro */
	local i 1
	while `"``i''"'!=`""' {
		local vl     `"`vl' bs`i'"'
		local labs   `"`labs' ``i''"'
		local stats  `"`stats' (``i'')"'

		Dollar ``i''

		capture scalar `x' = `s(mac)'
		if _rc {
			sret clear
			di in red `"error in statistic: ``i''"'
			exit 198
		}
		local i = `i' + 1
	}
	sret clear

/* Stuff in `0', if anything, should be options. */

	capture syntax [, NOWARN NOESAMPLE *]
	if _rc {
		di in red `"must enclose command in quotes and "' /*
		*/ `"list of statistics in quotes"'
		exit _rc
	}
	local 0 , `options'

/* do the resample check */
	_resamplecheck bs "`cmd'" "`nowarn'"
	if `"`s(needpreserve)'"' != "" & `"`noesample'"' == "" {
		preserve
		keep if e(sample)
	}

	global S_bs_vl  `"`vl'"'
	global S_bs_lab `"`labs'"'
	global S_bs_cmd `"`cmd'"'
	global S_bs_ver `"`version'"'
	global S_bs_st  `"`stats'"'

	bstrap _BS `0' /* program _BS is in bstrap.ado file */

	global S_bs_st
	global S_bs_ver
	global S_bs_cmd
	global S_bs_lab
	global S_bs_vl
	global S_bs_noi
end

program define Dollar, sclass /* put $ in front of any S_ */
	args mac
	sret clear
	local i = index(`"`mac'"',`"S_"')
	local n = length(`"`mac'"')
	local j 1
	while `i' != 0 & `j' <= `n' {
		local front = substr(`"`mac'"',1,`i'-1)
		local back  = substr(`"`mac'"',`i',.)
		local mac `"`front'$`back'"'
		local i = index(`"`mac'"',`"S_"')
		local j = `j' + 1 /* prevents infinite loop if error */
	}
	sret local mac `"`mac'"'
end
