*! version 3.3.5  06mar2002
program define ci, rclass byable(recall)
	version 6
	global S_1		/* # obs	*/
	global S_3		/* mean		*/
	global S_4		/* se of mean	*/
	global S_5		/* lower bound	*/
	global S_6		/* upper bound	*/

	syntax [varlist] [if] [in] [aw fw] [, /*
		*/ Level(integer $S_level) Poisson Binomial /*
		*/ Exposure(varname) BY(varlist) Total ]


	if "`by'"!="" {		/* backwards compatibility */
		if _by() {
			di in red /*
			*/ "by() option may not be combined with by prefix"
			exit 190
		}
		if "`weight'" != "" {
			local wgt `"[`weight'`exp']"'
		}
		if "`level'"!="" {
			local level "level(`level')"
		}
		if "`exposur'"!="" {
			local exposur "exposure(`exposur')"
		}
		by `by': ci `varlist' `if' `in' `wgt', /*
			*/ `level' `poisson' `binomia' `exposur' `total'
		exit
	}

	if "`total'"!="" & !_by() {
		di in red "option total may only be specified with by"
		exit 198
	}
		
	tokenize `varlist'

	if `level'<10 | `level'>99 { 
		di in red "level() invalid"
		exit 198
	}

	tempvar touse
	mark `touse' [`weight'`exp'] `if' `in'
	markout `touse' `exposur' /* but not `varlist' */

	if _by() & _bylastcall() & "`total'"!="" {
				/* set alluse for later use */
		tempvar alluse		
		mark `alluse' [`weight'`exp'] `if' `in', noby
		markout `alluse' `exposur' /* but not `varlist' */
	}

	if "`exposur'"!="" { 
		if "`binomia'"!="" { 
			di in red "exposure() invalid"
			exit 198
		}
		local poisson poisson
		capture assert `exposur'>0 if `touse'
		if _rc { 
			di in red "`exposur' <= 0"
			exit 402
		}
		local exposur "ex(`exposur')"
	}
	if "`weight'"=="aweight" & ("`binomia'"!="" | "`poisson'"!="") { 
		di in red "aweight not allowed"
		exit 101
	}
	local weight "[`weight'`exp']"
	tempvar BYGRP

	di
	Ci `varlist' `weight' if `touse', /*
		*/ level(`level') `binomia' `poisson' /*
		*/ `exposur'
	ret add  /* add return values from Ci */

	if _by() & _bylastcall() & "`total'"!="" {
		di _n in gr _dup(79) "_" _n "-> Total"
		if "`level'"!="" {
			local level "level(`level')"
		}
		if "`exposur'"!="" {
			local exposur "exposure(`exposur')"
		}
		ci `varlist' if `alluse' `weight', /*
			*/ `level' `poisson' `binomia' `exposur'
		return clear
		ret add
	}
end

/*
	In program Ci, we know the `if' is resolved to a touse variable
	and marks out everything except the missing values of the 
	variables.  Therefore, we do not reduce it again but just use `if'
*/

program define Ci, rclass
	syntax varlist [aw fw] [if] [, Level(integer $S_level) /*
		*/ Binomial Poisson Ex(varname) ]

	tempvar tousex
	local ttl "    Mean"
	local tl1 "    Obs "
	if "`binomia'"!="" { 
		di in smcl in gr _col(56) /*
			*/ "{hline 2} Binomial Exact {hline 2}"
	}
	else if "`poisson'"!="" {
		di in smcl in gr _col(56) /*
			*/ "{hline 2} Poisson  Exact {hline 2}"
		local tl1 "Exposure"
	}
	#delimit ;
	di in smcl in gr 
"    Variable {c |} `tl1'    `ttl'    Std. Err.       [`level'% Conf. Interval]"
	_n "{hline 13}{c +}{hline 61}" ;
	#delimit cr
	global S_1 0
	global S_2 .
	global S_3 . 
	global S_4 . 
	global S_5 . 
	global S_6 . 

	local marked 0 
	tokenize `varlist'
        while ("`1'"!="") {
		local mark
		local toprt 1
		capture confirm string var `1'
		if _rc==0 { 
			local toprt 0
		}
		else {
			if "`binomia'"!="" { 
				capture assert `1'==0 | `1'==1 | `1'==. `if'
				if _rc { 
					local toprt 0
				}
				else { 
					qui sum `1' [`weight'`exp'] `if'
					local n = r(N)
					local k = int(r(mean)*r(N)+.5)
					ret scalar N = `n'
					ret scalar mean = `k'/`n'
					ret scalar se=sqrt((return(mean)* /*
						*/ (1-return(mean)))/`n')
					ret scalar lb=invbinomial(`n',`k',/*
	                                        */ (100-`level')/200)
					ret scalar ub=invbinomial(`n',`k',/*
	                                        */ 1-(100-`level')/200)
					/* double save in S_# and r() */
					global S_1 `return(N)'
					global S_3 `return(mean)'
					global S_4 `return(se)'
					global S_5 `return(lb)'
					global S_6 `return(ub)'
					if `k'==0 | `k'==`n' {
						local mark "*"
						local marked 1
					}
				}
			}
			else if "`poisson'"!="" { 
				capture assert `1'>=0 | `1'==. `if'
				if _rc { 
					local toprt 0
				}
				else {
					capture drop `tousex'
					mark `tousex' `if'
					markout `tousex' `1'
					qui sum `1' [`weight'`exp'] `if'
					local n = r(N)
					local k = int(r(mean)*r(N)+.5)
					if "`ex'"!="" { 
	    				    qui sum `ex' [`weight'`exp'] /*
							*/ `if' & `tousex'
					    local n = r(mean)*r(N)
					}
					/* The missing condition only happens when there are no observations in the by() group */
					if "`k'" != "." {
						_crccip `k' `level'
					
						ret scalar lb = `r(lower)'/`n'
						ret scalar ub = `r(upper)'/`n'
						ret scalar N = `n'
						ret scalar mean = `k'/`n'
						ret scalar se = sqrt(`k')/`n'
					}
					/* double save in S_# and r() */
					global S_1 `return(N)'
					global S_3 `return(mean)'
					global S_4 `return(se)'
					global S_5 `return(lb)'
					global S_6 `return(ub)'
					if `k'==0 { 
						local mark "*"
						local marked 1
					}
				}
			}
			else { 
				qui summ `1' [`weight'`exp'] `if'
				ret scalar N = r(N)
				ret scalar mean = r(mean)
				ret scalar se = sqrt(r(Var)/r(N))
				local invt = invt(r(N)-1, `level'/100)
				ret scalar lb = r(mean) - `invt'*return(se)
				ret scalar ub = r(mean) + `invt'*return(se)
				/* double save in S_# and r() */
				global S_1 `return(N)'
				global S_3 `return(mean)'
				global S_4 `return(se)'
				global S_5 `return(lb)'
				global S_6 `return(ub)'
			}
			if `toprt' { 
				local fmt : format `1'
				if substr("`fmt'",-1,1)=="f" { 
					local ofmt="%9."+substr("`fmt'",-2,2)
				}
				else if substr("`fmt'",-2,2)=="fc" {
					local ofmt="%9."+substr("`fmt'",-3,3)
				}
				else	local ofmt "%9.0g"
				di in smcl in gr /*
				*/ %12s abbrev("`1'",12) " {c |}" _col(14) /*
				*/ in yel %8.0f return(N) /*
		 		*/ _col(27) `ofmt' return(mean) /*
		 		*/ _col(39) `ofmt' return(se) /*
		 		*/ _col(55) `ofmt' return(lb) /*
		 		*/ _col(67) `ofmt' return(ub) in gr "`mark'"
			}
		}
		mac shift
	}
	if `marked' { 
		di _n in gr "(*) one-sided, " 100-(100-`level')/2 /*
		*/ "% confidence interval"
	}
end
exit
