*! version 1.3.1  29jan2002
program define codebook
	version 6
	syntax [varlist] [, All Tabulate(integer 9) Mv Notes Header]

	if "`all'" != "" { 
		local header "header"
		local notes "notes"
	}

	if "`header'" != "" {
		Header, `notes'
	}

	foreach n of local varlist {
		local lbl : variable label `n'
		if `"`lbl'"'=="" { local lbl "(unlabeled)" }
		if length(`"`lbl'"')<=40 {
			local l = 77-length(`"`n'"')-length(`"`lbl'"')
			di in smcl _n(2) in ye `"`n' "' in gr "{hline `l'}" /*
			*/ in ye `" `lbl'"'
		}
		else {
			local l = 77-length(`"`n'"')-40
			di _n(2) in smcl in ye `"`n' "' /*
				*/ in gr "{hline `l'}" " " _c 
			Piece yellow 40 40 `"`lbl'"'
		}

		capture confirm string variable `n'
		if _rc {
			local fmt : format `n'
			local ch = substr(`"`fmt'"', 2, 1)
			if `"`ch'"'=="d" | `"`ch'"'=="t" {
				DoDate `n' `tabulat' `mv'
			}
			else	DoNum `n' `tabulat' `mv' 
		}
		else	DoStr `n' `tabulat' `mv'
		if "`notes'"!="" {
			note `n'
		}
	}
end


program define DoNum
	args v tabulat mv

	local type : type `v'
	local tabvar `v'
	di _col(19) in gr "type:  " /*
		*/ in gr "numeric (" in ye `"`type'"' in gr ")"

	local lbl : value label `v'
	if `"`lbl'"'!="" {
		tempvar decode 
		di _col(18) in gr "label:  " in ye `"`lbl'"' _c
		capture decode `v', gen(`decode')
		if _rc { 
			di in gr ", but label does not exist"
		}
		else {
			local tabvar `"`decode'"'
			sort `v'
			tempvar cnt
			qui by `v': gen byte `cnt'=1 /*
				*/ if _n==1 & `v'!=. & `decode'==""
			qui sum `cnt', meanonly 
			if r(sum) { 
				di in gr ", but " in ye r(sum)  	/*
					*/ in gr " value" 		/* 
					*/ cond(r(sum)==1," is", "s are")/*
					*/ " not labeled"
			}
			else	di
			drop `cnt'
		}
	}

	CntUniq `v' 
	local miss = r(miss)
	local uniq = r(uniq)

	di
	_crcunit `v'
	di _col(18) in gr "range:  [" in ye r(min) /*
		*/ in gr "," in ye r(max) in gr "]" _col(55) /* 
		*/ in gr "units:  " in ye r(units)

	ShowUniq `uniq' `miss'

	di
	if `uniq'<=`tabulat' {
		FullTab n `v' `tabvar'
	}
	else if `"`tabvar'"'==`"`v'"' {
		qui sum `v', detail
		di in gr _col(19) "mean:" in ye _col(26) %8.0g r(mean) _n /*
		*/ in gr _col(15) "std. dev:" in ye /*
			*/ _col(26) %8.0g sqrt(r(Var)) 
		di in gr _n _col(12) "percentiles:" _col(32) "10%" /*
			*/ _col(42) "25%" _col(52) "50%" _col(62) "75%" /*
			*/ _col(72) "90%"
		di in ye   _col(26) %8.0g r(p10) /* 
			*/ _col(36) %8.0g r(p25) /* 
			*/ _col(46) %8.0g r(p50) /* 
			*/ _col(56) %8.0g r(p75) /*
			*/ _col(66) %8.0g r(p90)
	}
	else {
		sort `v'
		di _col(15) in gr "examples:  " /* 
			*/  in ye (`v'[.2*_N]) _col(32) in gr `decode'[.2*_N]
		di _col(26) in ye (`v'[.4*_N]) _col(32) in gr `decode'[.4*_N]
		di _col(26) in ye (`v'[.6*_N]) _col(32) in gr `decode'[.6*_N]
		di _col(26) in ye (`v'[.8*_N]) _col(32) in gr `decode'[.8*_N]
	}

	capture drop `decode'
	if `"`mv'"'!="" { _crcmiss `v' _all }

end


program define DoDate
	args v tabulat mv

	local type : type `v'
	local tabvar `v'

	local fmt : format `v'
	local ch1 = substr(`"`fmt'"',2,1)
	local ch2 = substr(`"`fmt'"',3,1)
	if `"`ch1'"'=="d" {
		local ch1 "t"
		local ch2 "d"
	}
	if `"`ch2'"'=="d" {
		local desc "daily"
		local udesc "days"
	}
	else if `"`ch2'"'=="w" {
		local desc "weekly"
		local udesc "weeks"
	}
	else if `"`ch2'"'=="m" {
		local desc "monthly"
		local udesc "months"
	}
	else if `"`ch2'"'=="q" {
		local desc "quarterly"
		local udesc "quarters"
	}
	else if `"`ch2'"'=="h" {
		local desc "halfyearly"
		local udesc "half years"
	}
	else if `"`ch2'"'=="y" {
		local desc "yearly"
		local udesc "years"
	}
	else	DoNum `v' `tabulate' `mv'

	local bfmt "%t`ch2'"


	di _col(19) in gr "type:  " /*
		*/ in gr "numeric `desc' date (" in ye `"`type'"' in gr ")"

	local lbl : value label `v'
	if `"`lbl'"'!="" {
		tempvar decode 
		di _col(18) in gr "label:  " in ye `"`lbl'"' _c
		capture decode `v', gen(`decode')
		if _rc { 
			di in gr ", but label does not exist"
		}
		else {
			local tabvar `"`decode'"'
			sort `v'
			tempvar cnt
			qui by `v': gen byte `cnt'=1 /*
				*/ if _n==1 & `v'!=. & `decode'==""
			qui sum `cnt', meanonly 
			if r(sum) { 
				di in gr ", but " in ye r(sum)  	/*
					*/ in gr " value" 		/* 
					*/ cond(r(sum)==1," is", "s are")/*
					*/ "not labeled"
			}
			else	di
			drop `cnt'
		}
	}

	CntUniq `v' 
	local miss = r(miss)
	local uniq = r(uniq)

	di
	_crcunit `v'
	di _col(18) in gr "range:  [" in ye r(min) /*
		*/ in gr "," in ye r(max) in gr "]" _col(55) /* 
		*/ in gr "units:  " in ye r(units)
	di _col(8) in gr "or equivalently:  [" in ye /*
		*/ trim(string(r(min),"`bfmt'")) in gr "," in ye /*
		*/ trim(string(r(max),"`bfmt'")) in gr "]" in gr /*
		*/ _col(55) "units:  " in ye "`udesc'"

	ShowUniq `uniq' `miss'

	di
	if `uniq'<=`tabulat' {
		FullTab d `v' `tabvar' `bfmt'
	}
	else if `"`tabvar'"'==`"`v'"' {
		qui sum `v', detail
		local x = trim(string(r(mean), "`bfmt'"))
		if "`x'"=="." {
			local xnote " (invalid `desc' date)"
		}
		else {
			local diff = r(mean) - int(r(mean))
			if `diff' != 0 { 
				if "`ch2'"=="d" {
					local diff=round(24*`diff',1)
					local xnote "hour"
				}
				else if "`ch2'"=="w" {
					local diff=trim(string( /*
						*/ 7*`diff', "%9.1f"))
					local xnote "day"
				}
				else if "`ch2'"=="m" {
					local diff=round(365.25/12*`diff',1)
					local xnote "day"
				}
				else if "`ch2'"=="q" { 
					local diff=trim(string(/*
						*/ 3*`diff',"%9.1f"))
					local xnote "month"
				}
				else if "`ch2'"=="h" {
					local diff=trim(string(/*
						*/ 6*`diff',"%9.1f"))
					local xnote "month"
				}
				else {
					local diff=trim(string(/*
						*/ 6*`diff',"%9.1f"))
					local xnote "month"
				}
				if `diff'==int(`diff') {
					local diff = int(`diff') /* sic */
				}
/*
				if "`diff'"=="1.0" {
					local diff "1"
				}
*/
				if "`diff'" != "1" {
					local xnote "`xnote's"
				}
				local xnote " (+ `diff' `xnote')"
			}
		}
		di in gr _col(19) "mean:" in ye _col(26) %8.0g r(mean) /*
		*/ in gr " = " in ye "`x'" in gr "`xnote'" _n /*
		*/ in gr _col(15) "std. dev:" in ye /*
			*/ _col(26) %8.0g sqrt(r(Var)) 
		di in gr _n _col(12) "percentiles:" _col(32) "10%" /*
			*/ _col(42) "25%" _col(52) "50%" _col(62) "75%" /*
			*/ _col(72) "90%"
		di in ye   _col(26) %8.0g r(p10) /* 
			*/ _col(36) %8.0g r(p25) /* 
			*/ _col(46) %8.0g r(p50) /* 
			*/ _col(56) %8.0g r(p75) /*
			*/ _col(66) %8.0g r(p90)

		di in gr  in ye /* 
			*/ _col(25) %9s trim(string(r(p10),"`bfmt'")) /* 
			*/ _col(35) %9s trim(string(r(p25),"`bfmt'")) /* 
			*/ _col(45) %9s trim(string(r(p50),"`bfmt'")) /* 
			*/ _col(55) %9s trim(string(r(p75),"`bfmt'")) /*
			*/ _col(65) %9s trim(string(r(p90),"`bfmt'"))
	}
	else {
		sort `v'
		di _col(15) in gr "examples:  " /* 
			*/  in ye (`v'[.2*_N]) _col(32) in gr `decode'[.2*_N]
		di _col(26) in ye (`v'[.4*_N]) _col(32) in gr `decode'[.4*_N]
		di _col(26) in ye (`v'[.6*_N]) _col(32) in gr `decode'[.6*_N]
		di _col(26) in ye (`v'[.8*_N]) _col(32) in gr `decode'[.8*_N]
	}

	capture drop `decode'
	if `"`mv'"'!="" { _crcmiss `v' _all }

end

program define DoStr
	args v tabulat mv
	tempvar cnt

	local type : type `v'
	local tabvar `v'

	di _col(19) in gr "type:  " /*
		*/ in gr "string (" in ye `"`type'"' in gr ")" _c
	qui gen byte `cnt'=length(`v')
	qui sum `cnt', meanonly
	if r(max)!= real(substr("`type'",4,.)) { 
		di in gr ", but longest is str" r(max)
	}
	else	di
	drop `cnt'

	di
	CntUniq `v'
	ShowUniq `r(uniq)' `r(miss)'
	di

	if r(uniq)<=`tabulat' {
		FullTab s `v' `tabvar'
	}
	else { 
		sort `v'
		di in gr _col(15) "examples:  " _c 

		local x = `v'[.2*_N]
		Piece yellow 26 53 `""`x'""'

		local x = `v'[.4*_N]
		di _col(26) _c
		Piece yellow 26 53 `""`x'""'

		local x = `v'[.6*_N]
		di _col(26) _c
		Piece yellow 26 53 `""`x'""'

		local x = `v'[.8*_N]
		di _col(26) _c
		Piece yellow 26 53 `""`x'""'
	}

	if `"`mv'"'!="" { _crcmiss `v' _all }

	quietly { 
		count if substr(`v',1,1)==" "
		if r(N) { 
			local haslead 1 
			local ttl "leading"
		}
		else 	local haslead 0
		count if substr(`v',-1,1)==" "
		if r(N) { 
			local hastrai 1 
			local ttl "trailing"
		}
		else 	local hastrai 0
		if `haslead' | `hastrai' {
			tempvar clean
			gen `type' `clean'=trim(`v')
			capture assert index(`clean'," ")==0
			drop `clean'
		}
		else	capture assert index(`v'," ")==0
		if _rc { 
			local hasem 1 
			local ttl "embedded"
			}
		else 	local hasem 0
	}
	if `haslead' + `hastrai' + `hasem' >= 2 {
		if `haslead' & `hastrai' & `hasem' {
			local ttl "leading, embedded, and trailing"
		}
		else if `haslead' & `hastrai' {
			local ttl "leading and trailing"
		}
		else if `haslead' & `hasem' { 
			local ttl "leading and embedded"
		}
		else	local ttl "embedded and trialing"
	}
	if `haslead' | `hastrai' | `hasem' {
		di _n in gr _col(16) "warning:  variable has `ttl' blanks"
	}
end


program define FullTab /* n|d|s varname tabvar [bfmt] */
	args vtype v tabvar bfmt

	tempvar cnt first
	sort `v'
	quietly by `v': gen long `cnt'=_N
	quietly by `v': gen byte `first'=1 if _n==1
	sort `first' `v' 
	di in gr _col(13) "tabulation:  Freq.  " _c

	if `"`v'"'!=`"`tabvar'"' {
		di in gr " Numeric  Label"
	}
	else 	di in gr "Value"

	local j 1
	while `first'[`j']==1 {
		if missing(`v'[`j'])==0 { 
			if `"`tabvar'"'!=`"`v'"' {
				di _col(24) %7.0g `cnt'[`j'] /*
				*/ _col(33) %8.0g (`v'[`j']) /*
					*/ in gr _col(43) _c
				local s = `tabvar'[`j']
				Piece gr 43 32 `"`s'"'
			}
			else if "`vtype'"=="n" {
				di _col(24) %7.0g `cnt'[`j'] /*
				*/ _col(33) (`v'[`j'])
			}
			else if "`vtype'"=="d" {
				di _col(24) %7.0g `cnt'[`j'] /*
				*/ _col(33) (`v'[`j']) /*
				*/ in gr _col(40) `bfmt' (`v'[`j'])
			}
			else {
				di _col(24) %7.0g `cnt'[`j'] /*
				*/ _col(33) _c 
				local s = `v'[`j']
				Piece ye 33 40 `""`s'""'
			}
		}
		local j=`j'+1
	}
end



program define CntUniq, rclass
	tempvar cnt
	quietly {
		sort `1'
		by `1': gen long `cnt'=1 if _n==1
		replace `cnt'=sum(`cnt')
		local uniq=`cnt'[_N]
		count if missing(`1')
		ret scalar miss=r(N)
		ret scalar uniq=`uniq'-(r(N)!=0)
	}
end

program define ShowUniq
	args uniq miss
	di in gr _col(10) "unique values:  " in ye `"`uniq'"' /* 
		*/ _col(47) in gr "coded missing:  " in ye `miss' /*
		*/ in gr " / " in ye _N
end





program define _crcmiss /* varlist */
	syntax varlist(min=2)
	tokenize `varlist'
	local v `"`1'"'
	mac shift
	local frst 1
	tempvar ismiss newmiss
	capture confirm string var `v'
	if _rc==0 { 
		local vs 1
		capture assert `v'!=""
		if _rc==0 { exit } 
		qui gen byte `ismiss'=`v'==""
	}
	else {
		local vs 0
		capture assert `v'!=.
		if _rc==0 { exit } 
		qui gen byte `ismiss'=`v'==.
	}
	qui gen byte `newmiss'=.
	while `"`1'"'!="" {
		if `"`1'"'!=`"`v'"' {
			capture confirm string var `1'
			if _rc==0 {
				qui replace `newmiss'=`1'==""
				local 1s 1
			}
			else {
				qui replace `newmiss'=`1'==.
				local 1s 0
			}
			capture assert `newmiss'==0 
			if _rc { 
				capture assert `ismiss' if `newmiss'
				if _rc==0 { 
					if `frst' {
						di in gr _n _col(9) /* 
						*/ "missing values:" _c
						local frst 0
					}
					else	di _col(24) _c
					local l=9-length(`"`1'"')+2
					di _skip(`l') _c
					if `1s' {
						di in gr `"`1'=="' /*
							*/ _quote _quote _c
					}
					else {
						di in gr `"`1'==. "' _c
					}
					capture assert `newmiss' if `ismiss'
					if _rc==0 { di in gr "<-> " _c }
					else 	di in gr "--> " _c
					if `vs' { 
						di in gr `"`v'=="' _quote _quote 
					}
					else di in gr `"`v'==."'
				}
			}
		}
		mac shift
	}
end


program define _crcunit, rclass /* varname */
	local p 1
	capture assert `1'==. 
	if _rc==0 { 
		ret scalar units = .
		ret scalar min = .
		ret scalar max = .
		exit
	}
	capture assert `1'==. | `1'==0
	if _rc==0 { 
		ret scalar units = 0
		ret scalar min = 0
		ret scalar max = 0
		exit
	}
	capture assert float(`1')==float(round(`1',1))
	if _rc == 0 { 
		while _rc==0 { 
			local p=`p'*10
			capture assert float(`1')==float(round(`1',`p'))
		}
		local p=`p'/10
	}
	else {
		while _rc { 
			local p=`p'/10
			capture assert float(`1')==float(round(`1',`p'))
		}
	}
	qui summ `1'
	ret scalar units = `p'
	ret scalar min = round(r(min),`p')
	ret scalar max = round(r(max),`p')
	ret scalar mean = r(mean)
	ret scalar Var = r(Var)
end

program define Piece
	args color col len str

	local piece : piece 1 `len' of `"`str'"'
	di in `color' `"`piece'"'

	local i 2
	local piece : piece 2 `len' of `"`str'"'
	while `"`piece'"' != "" {
		di in `color' _col(`col') `"`piece'"'
		local i = `i' + 1
		local piece : piece `i' `len' of `"`str'"'
	}
end

program define Header
	syntax [, Notes]
	di

	di in gr _col(18) "Dataset:  " _c
	if `"$S_FN"'=="" { 
		di in gr "[no name]"
	}
	else	di in ye `"$S_FN"'

	di in gr _col(15) "Last saved:  " _c
	if `"$S_FN"'=="" {
		di in gr "never"
	}
	else if `"$S_FNDATE"'=="" {
		di in gr "unknown"
	}
	else	di in ye `"$S_FNDATE"'

	if `"$S_FN"'!="" {
		qui des, short
		if r(changed) {
			di in gr _col(28) "DATA HAVE CHANGED SINCE LAST SAVED"
		}
	}


	di
	local x : data label
	if `"`x'"'=="" {
		local x "[none]"
	}
	di in gr _col(20) "Label:  " in ye `"`x'"'

	capture memory
	if _rc {
		if _rc==1 { 
			exit 1 
		}
		local ptrsize 4
	}
	else	local ptrsize = r(size_ptr)
	qui desc, short
	di _col(6) in gr "Number of variables:  " /*
		*/ in ye trim(string(r(k),"%16.0gc"))
	di _col(3) in gr "Number of observations:  " /*
		*/ in ye trim(string(r(N),"%16.0gc"))
	di _col(21) in gr "Size:  " in ye /*
		*/ trim(string((r(width)+`ptrsize')*r(N),"%16.0gc")) /* 
		*/ in gr " bytes ignoring labels, etc."

	if "`notes'"!="" {
		notes _dta
	}
end

		

exit
/*



longlong ------------------------------------------ average january temperature
	          type:  numeric (int)
	         label:  gould, but 2 values are not labeled
	         range:  [xxx,xxx]
	         units:  1
	 unique values:  5
	 coded missing:  72
            Tabluation:  Freq.   Numeric  label
		       xxxxxxx  xxxxxxxx  (none)
		       1234567  12345678
 Or:
            Tabluation:  Freq.  value
		        xxxxxx  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

         1         2         3
12345678901234567890123456789012345678901234
               Warning:  variable has leading, trailing, embedded blanks

	
	
*/
