*! version 1.2.7  05sep2001
program define hettest, rclass
	version 6.0
	syntax [varlist(default=none)]
	_isfit cons anovaok

	if "`e(wtype)'"=="pweight" {
		di in red "hettest not appropriate with pweighted data"
		exit 498
	}
	if "`e(vcetype)'"=="Robust" { 
		if "`e(clustvar)'"!="" {
			di in red /*
			*/ "hettest not appropriate after robust cluster()"
			exit 498
		}
		if "`e(wtype)'"=="aweight" | "`e(wtype)'"=="aweight" {
			di in red "hettest not appropriate with robust and " /*
			*/ "`e(wtype)'ed data"
			exit 498
		}
	}

	tokenize `varlist'
	while `"`1'"' != "" {
		if `"`1'"' == `"`e(depvar)'"' { 
			local n : word count `varlist'
			if `n'==1 {
				local varlist
			}
			else {
				di in red `"`1' may not be specified"'
				exit 499
			}
		}
		mac shift
	}

	tempvar ui use
	tempname ehold

	if `"`e(wtype)'"' != "" { 
		local wgt `"[`e(wtype)' `e(wexp)']"'
	}
	qui gen byte `use' = e(sample)

	quietly {
		_predict double `ui' if `use', resid
		replace `ui' = `ui'^2/(e(rss)/e(N))

		if `"`varlist'"'=="" { 
			tempvar z
			_predict float `z' if `use' 
			local varlist `"`z'"'
			local tt `"using fitted values of `e(depvar)'"'
		}
		else 	local tt "using variables specified"

		nobreak {
			estimate hold `ehold'
			reg `ui' `varlist' `wgt' if `use'
			ret scalar chi2 = e(mss)/2
			ret scalar df = e(df_m)
			estimate unhold `ehold'
		}
	}
	
	di
	di in gr `"Cook-Weisberg test for heteroskedasticity `tt'"'
	di in gr "     Ho: Constant variance"

	di _col(10) in gr "chi2(" in ye `return(df)' in gr ")" /*
	*/ _col(23) "=" in ye /*
	*/	_col(25) %9.2f return(chi2)
	di _col(10) in gr "Prob > chi2  =" in ye _col(30) /*
	*/	%6.4f chiprob(return(df),return(chi2)) 

	if (1) {    /* double save in S_# and r() */
		global S_3 `return(df)'
		global S_5
		global S_6 `return(chi2)'
	}
end
