*! version 7.0.8  06aug2001
program define jknife, rclass
	version 7
	if _caller()<=6 {
		jknife_6 `0'
		exit
	}
	local vers = _caller()
					/* begin parsing 	*/
	gettoken cmd   0: 0
	if `"`cmd'"'==`""' { error 198 }

	local k 0
	_getxel first _jk `0'
	while `s(found)' {
		local k = `k' + 1
		local name1_`k' `"`s(name)'"'
		local exp1_`k' `"`s(exp)'"'
		local eexp1_`k' `"`s(eexp)'"'
		local 0 `s(rest)'
		_getxel second _jk `0'
	}
	if `k'==0 {
		di as err "list of statistics not found"
		error 198
	}


	#delimit ;
	syntax [if] [in] [,
		Eclass
		KEEP
		Level(integer $S_level)
		N(string)
		NOESAMPLE
		Rclass
		] ;
	#delimit cr
	local nfunc `"`n'"'
					/* begin mark sample	*/

	tempvar touse
	mark `touse' `if' `in'
	qui replace `touse' = 2 if `touse'==0		/* sic */
	qui count if `touse'==1
	local touseN = r(N)
					/* end mark sample	*/


	if `"`if'"' != "" | `"`in'"'!="" {
		if `"`if'"'!="" & `"`in'"'!="" {
			local ifin `"`cma' `if' `in'"'
		}
		else if `"`if'"' != "" {
			local ifin `"`cma' `if'"'
		}
		else	local ifin `"`cma' `in'"'
	}

	if ("`eclass'"!="") + ("`rclass'"!="") + (`"`nfunc'"'!="")>1 {
		di as err /*
		*/ "options rclass, eclass, and n() are mutually exclusive"
		exit 198
	}
	if "`rclass'" != "" {
		local nfunc "r(N)"
	}
	else if "`eclass'"!="" {
		local nfunc "e(N)"
	}


	SetComma `cmd'
	local cma "`s(comma)'"
					/* end parsing 		*/


					/* begin run cmd on full sample */
	tempvar order
	qui gen long `order' = _n
	sort `touse' `order'
	qui replace `order' = _n	/* sic	*/

	version `vers'
	capture `cmd' `cma' if `touse'==1
	version 7
	if _rc {
		if _rc==1 { error 1 }
		di as err
		di as err `"error when command executed on original dataset:"'
		di as err
		di as err `"-> `cmd'`ifin'"'
		version `vers'
		`cmd' `cma' if `touse'==1
		version 7
		error _rc
		exit 198		/* in case no error 2nd time	*/
	}
					/* get full list of statistics */

	local ii 1
	forvalues i = 1(1)`k' {
		if `"`eexp1_`i''"' != `""' {
			_getxel2 `eexp1_`i''
			tokenize `eexp1_`i''
			local type `1'
			local eq `2'
			tempname B
			mat `B' = e(b)
			if "`eq'" != "" {
				mat `B' = `B'[1,"`eq':"]
			}
			local cnames : colnames `B'
			local c1 : word 1 of `cnames'
			local n `s(n)'
			if "`type'" == "_b" {
				local name`ii'= substr("b_`c1'",1,32)
			}
			else local name`ii' = substr("se_`c1'",1,32)
			local exp`ii' `"`s(e1)'"'
			local ii = `ii' + 1
			local temp `c1'
			forvalues j = 2(1)`n' {
				local cj : word `j' of `cnames'
				local cj5 = substr("`cj'", 1,29)
				local junk : subinstr local temp "`cj5'" /*
				*/ "`cj5'", all count(local m)
				local temp `temp' `cj'
				if substr("`cj'",1,1)=="_" {
					local cj = substr("`cj'",2,.)
				}
				if `m' == 0  {
					if "`type'" == "_b" {
					local name`ii' = substr("b_`cj'", 1,32)
					}
					else {
					local name`ii' = substr("se_`cj'", 1,32)
					}
				}
				else {
					if "`type'" == "_b" {
					local name`ii' = substr("b_`m'`cj'",1,32)
					}
					else {
					local name`ii' =substr("se_`m'`cj'",1,32)
					}
				}
				local exp`ii' `"`s(e`j')'"'
				local ii = `ii' + 1
			}
		}
		else {
                        local name`ii' `name1_`i''
                        local exp`ii' `exp1_`i''
                        local ii = `ii' + 1
		}
	}
	local K = `ii'-1
	forvalues i = 1(1)`K' {
		local names `names' `name`i''
	}

	confirm names `names'
	if "`keep'" != "" {
		confirm new var `names'
	}
						/* end of getting statistics */

						/* opening display */

	di as txt _n `"command:     `cmd'`ifin'"'

	if `K'==1 {
		local stathead statistic
	}
	else local stathead statistics
	di as txt `"`stathead':  `name1' = `exp1'"'
	local i 2
	while `i' <= `K' {
		dis as txt _col(14) `"`name`i'' = `exp`i''"'
		local i = `i' + 1
	}
	if `"`nfunc'"' != "" {
		di as txt  `"n():         `nfunc'"'
	}
	else {
		di as txt /*
*/ `"n():         (not specified)  <-- we strongly recommend that you specify"'
		di as txt _col(35) "the " as res "rclass" as txt ", " /*
		*/ as res "eclass" as txt ", or " as res "n()" as txt " option"
	}

/* do the resample check; jknife handles the non-eclass case correctly */
	if `"`nfunc'"' == "e(N)" & `"`noesample'"' == "" {
		_resamplecheck jknife "`cmd'"
		if `"`s(needpreserve)'"' != "" {
			preserve
			keep if e(sample) & `touse'==1
			qui count if `touse'==1
			local touseN = r(N)
		}
	} 
					/* end present opening display */

					/* save statistics */
	tempname N useit

	local prob 0
	local i 1
	while `i' <= `K' {
		tempname fstat`i'
		capture scalar `fstat`i'' = `exp`i''
		if _rc {
			di as err
			di as err `"syntax error in statistic:  `exp`i'':"'
			di as err
			di as err `"-> display `exp`i''"'
			display (`exp`i'')
			error _rc
		}
		local i = `i' + 1
	}
	if `"`nfunc'"' != "" {
		capture scalar `N' = int(`nfunc')
		if _rc {
			di as err
			di as err `"syntax error in n():  `nfunc'"'
			di as err
			di as err `"-> display `nfunc'"'
			display (`nfunc')
			error _rc
		}
		if `N'==. | `N'==0 {
			local zm = cond(`N'==.,"missing","zero")
			di as err /*
		*/ `"number of obs. `nfunc' evaluated to `zm' in full sample"'
			local prob 1
		}
	}
	else 	scalar `N' = `touseN'

	local i 1
	while `i' <= `K' {
		if `fstat`i'' == . {
			di as err /*
		*/ `"statistic `exp`i'' evaluated to missing in full sample"'
			local prob 1
		}
		local i = `i' + 1
	}
	if `prob' {
		exit 459
	}

					/* end run cmd on full sample	*/

					/* begin Jacknife		*/
	local i 1
	while `i' <= `K' {
		tempvar tv`i'
		qui gen double `tv`i'' = .
		local i = `i' + 1
	}

	scalar `useit' = 1
	local j 1
	sort `touse' `order'
	while `j' <= `touseN' {
		version `vers'
		qui `cmd' `cma' if `order'!=`j' & `touse'==1
		version 7
		sort `touse' `order'
		if `"`nfunc'"'!="" {
			scalar `useit' = (int(`nfunc')==int(`N')-1)
		}
		if `useit' {
			local i 1
			while `i' <= `K' {
				qui replace `tv`i'' = `exp`i'' in `j'
				local i = `i' + 1
			}
		}
		local j = `j' + 1
	}
					/* end Jacknife		*/

					/* begin calc. pseudovalues */
	local i 1
	while `i' <= `K' {
		quietly replace `tv`i''=`N'*(`fstat`i''-`tv`i'')+`tv`i''
		local i = `i' + 1
	}
					/* end calc. pseudovalues */

					/* begin final report	*/
					/* ... save in r()	*/
	#delimit ;
	di in smcl as txt _n
"Variable            {c |}     Obs    Statistic    Std. Err.   [`level'% Conf.
Interval]" _n "{hline 20}{c +}{hline 58}" ;
	#delimit cr

	local i 1
	while `i'<=`K' {
		quietly count if `tv`i'' != .
		ret scalar N`i' = r(N)
		ret scalar stat`i' = `fstat`i''
		di in smcl as txt abbrev("`name`i''", 12) _col(21) "{c |}"
		di in smcl as txt "            overall {c |}" as res %8.0f /*
			*/ return(N`i') /*
			*/ _col(34) %9.0g return(stat`i')
		quietly ci `tv`i'', level(`level')
		ret scalar mean`i' = r(mean)
		ret scalar se`i'   = r(se)
		di in smcl as txt "             jknife {c |}" as res /*
		 	*/ _col(34) %9.0g return(mean`i') /*
		 	*/ _col(46) %9.0g return(se`i') /*
		 	*/ _col(58) %9.0g r(lb) /*
		 	*/ _col(70) %9.0g r(ub)
		local i=`i'+1
	}
					/* end final report	*/

					/* begin renaming	*/

	if "`keep'"!="" {
		local i 1
		while `i' <= `K' {
			label var `tv`i'' `"`exp`i'' pseudovalues"'
			rename `tv`i'' `name`i''
			local i = `i' + 1
		}
	}
					/* end renaming		*/
end

program define SetComma, sclass
	sret clear

	local cma 0
	gettoken tok 0 : 0, parse(" ,([") match(par) quotes
	while `"`tok'"' != "" {
		if `"`tok'"' == "," {
			local cma = !`cma'
		}
		gettoken tok 0 : 0, parse(" ,([") match(par) quotes
	}
	sret local comma = cond(`cma', ",", "")
end
exit

/*
An ancient, known-to-work version of SetComma:

program define SetComma, sclass
	version 4.0
	sret clear
	parse "`*'", parse(" ()[],")
	local np 0
	local cma 0
	local i 1
	while "``i''" != "" {
		if "``i''"=="(" | "``i''"=="[" {
			local np = `np'+1
		}
		else if "``i''"==")" | "``i''"=="]" {
			local np = `np'-1
		}
		else if "``i''"=="," & `np'==0 {
			local cma= (!`cma')
		}
		local i=`i'+1
	}
	if `cma' {
		sret local comma ","
	}
end
*/
