*! version 1.2.2  06may2002
program define mfx
	local ver = _caller()
	global T_mfver "version `ver':"
	version 6

	gettoken first 0 : 0, parse(" ,")
	if "`first'" == "" {
	dis in red `"type "mfx compute" to compute the marginal effects"'	
	dis in red `"type "mfx replay" to replay the results"'
		capture mac drop T_mfver
		exit 198
	}
	if index("compute", "`first'") == 1 {
		 syntax [if] [in] [, noSe force *]
		 if "`se'" == "" & "`force'" == "" {   /* std. errors wanted */
		 	CheckPredict `if' `in', `options' version(`ver')
			capture mac drop T_mfver
			exit
		 }
		 /* nose specified or forced */
		 ClearEstResults
		 Estimate `if' `in', `options' `se'
	}
	else if index("replay", "`first'") == 1 {
		 Replay `0'
	}
	else {
	dis in red `"type "mfx compute" to compute the marginal effects"'	
	dis in red `"type "mfx replay" to replay the results"'
		capture mac drop T_mfver
		exit 198
	}
end

program define Estimate, eclass

	syntax [if] [in] [, AT(string) EQlist(string) PREDict(string) /*
	*/ dydx eyex dyex eydx NONLinear			      /*
	*/ noDiscrete noEsample noWght noSe Level(int $S_level) ]


								/* type */
	local type "`dydx'`eyex'`dyex'`eydx'"
	if "`type'" == "" { local type "dydx" }
	else if length("`type'") != 4 {
		dis in red "dydx, eyex, dyex, eydx are mutually exclusive"
		exit 198
	}
	if "`type'" == "dydx" | "`type'" == "dyex" { local lny  0 }
	else local lny  1	
			
	if ("`type'" != "dydx") { local discret "nodiscret'" }
		

	local fail 0
	marksample touse

	PredOpt	"`predict'"			/* get label for predict */
	local labelp "`s(labelp)'"
	local predict "`s(predict)'"

							/* `at' matrix */
	if "`at'" == "" {
		local at "mean"
	}
	_at "`at'"  "if `touse', `esample' `wght'" 
	tempname at  B
	mat `at' = r(at)
	mat `B' = e(b)
	local cnum = colsof(`B')
 						/* process equation list */

	tempname ism		 /* ism[1,i]!=0 if `at'[1,i] of interest  */
	mat `ism' = J(1, `cnum',0)
	GetEq `ism' "`eqlist'" `esample'
	local xseq "`s(xseq)'"		/* coleq of Xs of interest */
	local xscol "`s(xscol)'" 	/* colnames of Xs of interest */
	local total `s(total)'		/* # of Xs of interest */
	local dummy "`s(dummy)'"	/* 0 continuous 1 dummy	*/
	local flag "`s(flag)'"		/* 1 nonlinear 0 linear */
	if `total' == 0 {
		dis in red "equation(s) has no independent variables"
		exit 102 
	}

	if "`nonlinear'" != "" { local flag = 1 }
			
	tempname dfdx se_dfdx X old
	preserve
	est hold `old', copy
	cap noi {
		EstPost `at'			/* est repost for 2 situations 
						1. ts operator
						2. internal command */
		
		tempname y
		GetY `y' `at' "`predict'"			/* get y */

		if (`y' <= 0) & `lny' {
			dis in red "y=`y'< 0, `type' not available"
			exit 459
		} 
							/* get estimates */
						
		if `flag' {				    /* nonlinear */	
			NL_dydx `at' `ism' "`dummy'" `total' "`predict'" /*
				*/ "`discret'"	
		}					    
		else {					    /* linear    */
			 L_dydx `at' `ism' "`dummy'" `total' "`predict'" /*
				*/ "`discret'"
		}
		mat `dfdx' = r(dfdx)		
		mat `X' = r(realat)
							/* get se        */
		if "`se'" == "" {
			if `flag' {			   /* nonlinear  */
				NL_se `at' `ism' "`dummy'" `total' /*
				*/ "`predict'" "`discret'" `lny'  	
			}
			else {				   /* linear	 */
				L_se `at' `ism' "`dummy'" `total'  /*
				*/ "`predict'" "`discret'" `lny'  	
			}
			local fail "`r(fail)'"
			if ! `fail' { mat `se_dfdx' = r(se_dfdx) }
		}
	}
	est unhold `old'
	restore
	if _rc != 0 {
		exit _rc
	}
	if `fail'{
        	dis in gr "fail in calculating second derivative," /*
                */ " no standard deviation reported"
		local se "nose"
        }

	local i = 1
	while `i' <= colsof(`X') {
		if "`type'" == "eyex" {
			mat `dfdx'[1,`i'] = `X'[1,`i']/`y' * `dfdx'[1,`i']
		}
		if "`type'" == "dyex" {
			mat `dfdx'[1,`i'] = `X'[1,`i'] * `dfdx'[1,`i']
		}
		if "`type'" == "eydx" {
			mat `dfdx'[1,`i'] = `dfdx'[1,`i']/`y'
		}
		local i = `i' + 1 
	}
	mat colnames `dfdx' = `xscol'
	if "`se'" == "" {
		local i = 1
		while `i' <= colsof(`X') {
			if "`type'" == "eyex" {
				mat `se_dfdx'[1,`i']=`X'[1,`i']*`se_dfdx'[1,`i']
			}
			if "`type'" == "dyex" {
				mat `se_dfdx'[1,`i']=`X'[1,`i']*`se_dfdx'[1,`i']
			}
			local i = `i' + 1
		}
		mat colnames `se_dfdx' = `xscol'
	}
	mat colnames `X' = `xscol'

							/* return results */
	est mat Xmfx_X `X'
	est mat Xmfx_`type' `dfdx'
	if "`se'" == "" { est mat Xmfx_se_`type' `se_dfdx' }
	if `flag' { est local Xmfx_method "nonlinear" }
	else est local Xmfx_method "linear"
	est local Xmfx_dummy   "`dummy'"
	est local Xmfx_predict "`predict'"
	est local Xmfx_label_p "`labelp'"
	est local Xmfx_cmd	"mfx"
	if "`discret'" == "" {
		est local Xmfx_discrete "discrete"
	}
	else est local Xmfx_discrete "nodiscrete"
	est local Xmfx_type "`type'"
	est scalar Xmfx_y = `y'

								/* Display */
	if "`level'" != "" { local level "level(`level')" }
	Replay ,  `level'
	capture mac drop T_mfver
end


program define PredOpt, sclass
	args predict
	tempvar junk 
	$T_mfver qui predict `junk', `predict'
	local labelp : variable label `junk'
	drop `junk'
	if "`labelp'" == "" {
		if "`predict'" == "" {
			local labelp "predict(default)"
		}
		else local labelp "predict(`predict')"
	}
	local junk : subinstr local labelp "residual" "residual", 	/*
		*/ count(local res)
	local isres = `res'
	local junk : subinstr local labelp "Residual" "Residual", 	/*
		*/ count(local res)
	local isres = `isres' + `res'
	if `isres' > 0 {
		di in gr "note: predicted variable label contains residual"
		di in gr "      marginal effects might not be appropriate" 
		if "`e(cmd)'" == "regress" {
			di in gr "note: predict(residual) ignored for regress"
			local predict "xb"	
			local labelp "Fitted values"
		} 
	}	
	sret local labelp "`labelp'"
	sret local predict "`predict'"
end
	
program define GetEq, sclass
	args ism eqlist esamp
	tempname B   
	local flag = 0				/* variable in multiple eqs */
	mat `B'= e(b)
	local ename : coleq `B'
	local fullist
	tokenize `ename'
	local fullist `1'
	while "`2'" != "" {
		if "`2'" != "`1'" {
			local fullist "`fullist' `2'"
		}
		mac shift
	}
	if "`eqlist'" == "" {
		local eqlist `fullist'
	}
	else { 
		local list
		tokenize `fullist'
		tempname T
		local i = 1
		while "``i''" != "" {
			local eqlist : subinstr local eqlist "``i''" /*
			*/ "", count(local isin) word all 
			if `isin' {
				mat `T' = `B'[1,"``i'':"]
				local c = colsof(`T')
				if `c' == 1 {
					local cname : colnames `T'
					cap tsrevar `cname'
					if _rc == 0 {
						local list "`list' ``i''"
					} 
				}
				else local list "`list' ``i''"	
			}
			local i = `i' + 1
		}
		local eqlist : subinstr local eqlist " " "" , all
		if "`eqlist'" != "" {
			dis in gr "note: equation(s) `eqlist' not found"
		}
		local eqlist "`list'"
	}		
	local cnum = colsof(`B')
	local cname : colnames `B'
	local i 1
	local total 0 				/* # of Xs of interested */
	local xscol				/* Xs of interested */
	local xseq 		
	local dummy
	local isin = 0
	tokenize `fullist'
	while `i' <= `cnum' {
		local enamei : word `i' of `ename'
		local cnamei : word `i' of `cname'
		cap tsrevar `cnamei'
		if _rc == 0 {
			if "`eqlist'" == "" {		/* single equation */
				mat `ism'[1,`i'] = 1
				local total = `total' + 1
				local xscol "`xscol' `cnamei'"
				if "`esamp'"=="" {
		cap assert `cnamei' == 0 | `cnamei' == 1 if e(sample)
				}
				else {
		cap assert `cnamei' == 0 | `cnamei' == 1 | `cnamei' == .
				}
				if _rc == 0 { local dummy "`dummy' 1" }
				else	{ local dummy "`dummy' 0" }
			}
			else {
				local junk : subinstr local eqlist "`enamei'" /*
				*/ "`enamei'", count(local isin) word 
				local junk : subinstr local xscol "`cnamei'"  /*
				*/ "`cnamei'", count(local isdup) word
				if (`isin' != 0)  & (`isdup'== 0) {
					local j = 1
					while "``j''" != "`enamei'" {
						local j = `j' + 1
					}
					mat `ism'[1,`i'] = `j'
					local total = `total' + 1
					local xscol "`xscol' `cnamei'"
					local xseq  "`xseq' `enamei'"
					if "`esamp'"=="" {
		cap assert `cnamei'== 0 | `cnamei'== 1 if e(sample) 
					}
					else {
		cap assert `cnamei' == 0 | `cnamei' == 1 | `cnamei' == .
					}
					if _rc ==0 { local dummy "`dummy' 1" }
					else	{ local dummy "`dummy' 0" }
				}
				if `isin' & `isdup' { local flag = 1 }
			}
		}			
		local i = `i' + 1
	}
	sreturn local xseq "`xseq'"
	sreturn local xscol "`xscol'"
	sreturn local total `total' 
	sreturn local dummy "`dummy'"
	sreturn local flag `flag'
end


program define EstPost, eclass
	/* 1. ts operator */
	/* 2. logit probit ologit oprobit mlogit tobit */
	args at
	tempname B V 
	mat `B' = e(b)
	mat `V' = e(V)
	local cmd "`e(cmd)'"
	IsTs `B' `V' `at'
	local ts `s(ts)' 
	if "`cmd'" == "probit" {
                est post `B' `V', noclear
                est local cmd "svyprobit"
                est local predict "svylog_p"
		exit
        }
        if "`cmd'" == "logit" {
                est post `B' `V', noclear
                est local cmd "svylogit"
                est local predict "svylog_p"
		exit
        }
        if "`cmd'" == "mlogit" {
                est post `B' `V', noclear
                est local cmd "svymlogit"
		exit
        }
        if "`cmd'" == "ologit" | "`cmd'" == "oprobit" {
                local dep "`e(depvar)'"
                local cname : colnames `B'
		tokenize `cname'
		local fname
                while "`1'" != "" {
                        local junk : subinstr local 1 "_cut" "cut", count(local a)
                        if `a' == 1 {
                                local fname "`fname' `junk':_cons"
                        }
                        else local fname "`fname' `dep':`1'"
                        mac shift
                }
                mat colnames `B'= `fname'
                mat colnames `V'= `fname'
                mat rownames `V'= `fname'
                est post `B' `V', noclear
                if "`cmd'" == "oprobit" {
                        est local cmd "svyoprobit"
                        est local predict "ologit_p"
                }
                else est local cmd "svyologit"
		exit
        }
        if "`cmd'" == "tobit" {
                local cname : colnames `B'
                tokenize `cname'
                local fname
		while "`1'" != "" {
                        if "`1'" != "_se" {
                                local fname "`fname' model:`1'"
                        }
                        else local fname "`fname' sigma:_cons"
                        mac shift
                }
                tempname sigma
                scalar `sigma' = `B'[1,colsof(`B')]
                mat colnames `B' = `fname'
                mat colnames `V' = `fname'
                mat rownames `V' = `fname'
                est post `B' `V', noclear
                est scalar sigma = `sigma'
                est local cmd "intreg"
		exit
        }
	if `ts' {
		est post `B' `V', noclear
	}
end

program define CheckPost, eclass 
	tempname b2 v2
	mat `b2' = e(b)
	mat `v2' = e(V)
	local cmd "`e(cmd)'"            

	if "`cmd'"=="probit" | "`cmd'"=="dprobit" {               
		est post `b2' `v2', noclear
		est local cmd "svyprobit"
		est local predict "svylog_p"
		exit
	}
	if "`cmd'"=="logit" | "`cmd'"=="logistic" {
		est post `b2' `v2', noclear
		est local cmd "svylogit"
		est local predict "svylog_p"
		exit
	}
	if "`cmd'"=="mlogit" {
		est post `b2' `v2', noclear
		est local cmd "svymlogit"
		exit
	}
        if "`cmd'" == "ologit" | "`cmd'" == "oprobit" {
                local dep "`e(depvar)'"
                local cname : colnames `b2'
		tokenize `cname'
		local fname
                while "`1'" != "" {
                        local junk : subinstr local 1 /*
				*/ "_cut" "cut", count(local a)
                        if `a' == 1 {
                                local fname "`fname' `junk':_cons"
                        }
                        else local fname "`fname' `dep':`1'"
                        mac shift
                }
                mat colnames `b2'= `fname'
                mat colnames `v2'= `fname'
                mat rownames `v2'= `fname'
		est post `b2' `v2', noclear
                if "`cmd'" == "oprobit" {
                        est local cmd "svyoprobit"
                        est local predict "ologit_p"
                }
                else est local cmd "svyologit"
		exit
        }
        if "`cmd'" == "tobit" | "`cmd'" == "cnreg" {
                local cname : colnames `b2'
                tokenize `cname'
                local fname
		while "`1'" != "" {
                        if "`1'" != "_se" {
                                local fname "`fname' model:`1'"
                        }
                        else local fname "`fname' sigma:_cons"
                        mac shift
                }
                tempname sigma
                scalar `sigma' = `b2'[1,colsof(`b2')]
                mat colnames `b2' = `fname'
                mat colnames `v2' = `fname'
                mat rownames `v2' = `fname'
		est post `b2' `v2', noclear
                est scalar sigma = `sigma'
                est local cmd "intreg"
		exit
        }
	est post `b2' `v2', noclear
end

program define IsTs, sclass 		
	args B V at
	local cname : colname `B'
	tokenize `cname'
	local ts 0
	while "`1'" != "" {
		cap tsrevar `1'
		if _rc == 0 {
			if "`r(varlist)'" != "`1'" {
			local cname : subinstr local cname "`1'" "`r(varlist)'"
				local ts 1
			}
		}
		mac shift
	}
	if `ts' {
		mat colname `B' = `cname'
		mat colname `at' = `cname'
		mat rowname `V' = `cname'
		mat colname `V' = `cname'
	}
	sreturn local ts `ts'	
end

program define GetY
	args y X predopt
	tempvar Y
	local cname : colnames `X'
       	tokenize "`cname'"
       	local j=1
       	while "``j''" != "" {
               	if "``j''" != "_cons" {
                       	cap confirm var ``j''
                       	local rc1 = _rc
                       	cap confirm new var ``j''
                       	local rc2 = _rc
                       	if `rc1' == 0 | `rc2' == 0 {
                               	tempvar junk
                               	qui gen double `junk' = `X'[1,`j'] in 1
                               	cap drop ``j''
                               	rename `junk' ``j''
                       	}
               	}
               	local j = `j' + 1
       	}
	$T_mfver qui predict double `Y' in  1, `predopt'
	scalar `y' = `Y'[1]	
end

program define NL_dydx, rclass
	args 	at	/*
	*/	ism	/*
	*/	dummy	/*
	*/	total	/*
	*/	predict /*
	*/	discret

	tempname dfdx B realat 
	mat `B' = e(b)
	local cnum = colsof(`B')
	mat `dfdx' = J(1,`total', 0)
        mat colnames `dfdx' = `xscol'
	mat `realat' = J(1, `total', 0)

	local i 1
	local j 1
	while `i' <= `cnum' {
		if `ism'[1, `i'] != 0 {
			local isdum : word `j' of `dummy'
                        if `isdum' & ("`discret'" == "") {
				 _me_derd `at' `i' "`predict'" 0
			}
			else {
				_me_der `at' `i' "`predict'" 0
			}	
                        mat `dfdx'[1,`j'] = r(dfdx)
			mat `realat'[1,`j'] = `at'[1,`i']
			local j = `j' + 1
		}
		local i = `i' + 1
	}
	return matrix dfdx `dfdx'
	return matrix realat `realat'
end

program define L_dydx, rclass
        args    at      /*
        */      ism     /*
        */      dummy   /*
        */      total   /*
        */      predict /*
        */      discret 

        tempname dfdx se_dfdx realat B
        mat `B' = e(b)
        local cnum = colsof(`B')
        mat `dfdx' = J(1,`total', 0)
        mat `se_dfdx' = J(1, `total', 0)
        mat `realat' = J(1, `total', 0)
        tempname dfdxb eqnum
        _me_l_der `at' "`predict'" 0
        mat `dfdxb' = r(dfdxb)
	local i = 1
	local j = 1
	while `i' <= `cnum' {
		if `ism'[1,`i'] {
                        local isdum : word `j' of `dummy'
			if `isdum' & ("`discret'" == "" ) {
				_me_derd `at' `i' "`predict'" 0
				mat `dfdx'[1,`j'] = r(dfdx)
			}
			else {
				mat `dfdx'[1,`j'] =     /*
                                */ `dfdxb'[1,`ism'[1,`i']]*`B'[1,`i']
			}
			mat `realat'[1,`j'] = `at'[1,`i']
                        local j = `j' + 1
                }
                local i = `i' + 1
	}
	return matrix dfdx `dfdx'
	return matrix realat `realat'
end


program define NL_se, rclass
        args    at      /*
        */      ism     /*
        */      dummy   /*
        */      total   /*
        */      predict /*
        */      discret /*
	*/ 	lny	/*	1: ln(y) 0: y */

	tempname se_dfdx B
	mat `B' = e(b)
	local cnum = colsof(`B')
	local fail 0
	mat `se_dfdx' = J(1, `total', 0)
	local i = 1
        local j = 1
        while `i' < = `cnum' & (! `fail' ) {
                if `ism'[1,`i'] != 0 {
                        local isdum : word `j' of `dummy'
			if `isdum' & ("`discret'" == "") {
				cap me_std `at' `i' 1 "`predict'" `lny'
			}
			else  cap me_std `at' `i' 0 "`predict'" `lny'
			if _rc != 0 { local fail 1  }
			else mat `se_dfdx'[1,`j'] = r(se_dfdx) 
			local j = `j' + 1
		}		
		local i = `i' + 1
	}	
	if ! `fail' { return matrix se_dfdx `se_dfdx' }
	return local fail `fail'
end

program define L_se, rclass
        args    at      /*
        */      ism     /*
        */      dummy   /*
        */      total   /*
        */      predict /*
        */      discret /*
	*/ 	lny	/*	1: ln(y) 0: y */


	tempname se_dfdx B eqnum dmdxb dfdxb
	local fail 0
	mat `B' = e(b)
        local cnum = colsof(`B')
        _me_l_der `at' "`predict'" `lny'
        mat `dfdxb' = r(dfdxb)
	mat `se_dfdx' = J(1, `total', 0)
	cap _me_l_der2 `at' "`predict'" `lny'
	if _rc { local fail 1 }
        else {
		mat `dmdxb' = r(dmdxb)
        	mat `eqnum' = r(eqnum)
	}
	local i = 1
        local j = 1
        while `i' <= `cnum' & ( ! `fail' ) {
                if `ism'[1,`i'] {
                        local isdum : word `j' of `dummy'
			if `isdum' & ("`discret'" == "") {
				cap me_std `at' `i' 1 "`predict'" `lny'
				if _rc { local fail 1 }
				else mat `se_dfdx'[1,`j'] = r(se_dfdx)
			}
			else {
				me_l_std `at'           /* Xs
                             	*/       `i'            /*
                             	*/       `ism'          /* eq #
                             	*/       `eqnum'        /*
                             	*/       `dfdxb'        /*
                             	*/       `dmdxb'	/*
				*/	 `lny' 
				mat `se_dfdx'[1,`j'] = r(se_dfdx)
			}
			local j = `j' + 1
		}
		local i = `i' + 1
	}
	return local fail `fail'
	if ! `fail' { return matrix se_dfdx `se_dfdx' }
end
				

program define me_std, rclass
	version 6
        args    X               /* matrix of evaluation points
        */      i               /* index of X matrix
        */      isdum           /* 1 : dummy ;  0 : continuous
        */      predopt         /* predict option 
	*/	lny		/* 1 : ln(y); 0 : y */

        tempname dmdb DM se B V
        mat `B' = e(b)
        mat `V' = e(V)
        local m = colsof(`B')
        mat `DM' = J(1, `m', 0)
        local j = 1
        while `j' <= `m' {
                _me_der2 `X' `i' `j' `isdum' "`predopt'" `lny'
                scalar `dmdb' = r(dmdb)
                mat `DM'[1,`j'] = `dmdb'
                local j = `j'+1
        }
        mat `V'=`DM'*`V'*`DM''
        scalar `se' = sqrt(`V'[1,1])
        return scalar se_dfdx = `se'
end

program define me_l_std, rclass
	args	at		/* at matrix 
	*/	i		/* index of X 
	*/	ism		/* 
	*/	eqnum		/* matrix of eq # 
	*/	dfdxb		/* dfdxb matrix
	*/ 	dmdxb		/* dmdxb matrix */
	
	tempname B V DM dmdb eqnm se
	mat `B' = e(b)
	local eqname : coleq `B'
	mat `V' = e(V)
	local ncol = colsof(`B')
	mat `DM' = J(1,`ncol', 0)
	
	local j = 1
	while `j' <= `ncol' {
		scalar `dmdb' = `dmdxb'[`ism'[1,`i'], `eqnum'[1,`j']]	/*
		*/		* `B'[1,`i'] * `at'[1,`j'] 
		if `i' == `j' {
			scalar `dmdb' = `dmdb' + `dfdxb'[1,`ism'[1,`i']] 
		}
		mat `DM'[1,`j'] = `dmdb'
		local j = `j' + 1
	}
	mat `V' = `DM'*`V'*`DM''
	scalar `se' = sqrt(`V'[1,1])
	return scalar se_dfdx = `se'
end

program define Replay
	syntax [, Level(int $S_level)]
	local type "`e(Xmfx_type)'" 
	if "`level'" == "" {
		local level 95
	}

	tempname B SE X y
	scalar `y' = e(Xmfx_y)
	mat `X' = e(Xmfx_X)
	cap mat list e(Xmfx_se_`type') 
	if _rc { local se 0 }			/* se = 0  no std 	*/
	else local se 1				/* se = 1  report std 	*/

	mat `B' = e(Xmfx_`type')
	if `se' { mat `SE' = e(Xmfx_se_`type') }
		
	local cnum = colsof(`B')
	
	if "`type'" == "dydx" {	local title "dy/dx" }
	if "`type'" == "eyex" {	local title "ey/ex" }
	if "`type'" == "dyex" {	local title "dy/ex" }
	if "`type'" == "eydx" {	local title "ey/dx" }

	if "`e(Xmfx_predict)'" != "" { local predict ", `e(Xmfx_predict)'" }
	else local predict 
	di 	
	if "`type'" == "dydx" { di in gr "Marginal effects after `e(cmd)'" }
	else di in gr "Elasticities after `e(cmd)'" 
	di in gr `"      y  = `e(Xmfx_label_p)' (predict`predict')"'
	di in gr  "         = " in ye %10.0g `y'		

	if `se' { 
        	di in smcl in gr "{hline 9}{c TT}{hline 68}"
		Display `X' `B' `SE' "`level'" "`type'" "`title'"
	}
	else { 
        	di in smcl in gr "{hline 33}{c TT}{hline 45}"
		Display2 `X' `B' "`type'" "`title'" 
	}
end

program define ClearEstResults, eclass
	local type `e(Xmfx_type)'
	local list X `type' se_`type' type method dummy 
	local list `list' predict label_p cmd discrete y
	foreach res of local list {
		est local Xmfx_`res'
	}
	exit
end

program define CheckPredict, eclass
	syntax [if] [in] [, version(integer 6) *]
	tempname old new V oldest
	capture noi qui version `version':mfx compute `if' `in', `options' nose
	if _rc {
		exit _rc
	}

	capture matrix `old' = e(Xmfx_`e(Xmfx_type)')  
	
	est hold `oldest', copy
	preserve
	capture noisily nobreak {
		CheckPost
		mat `V' = e(V)
		local k = colsof(`V')
		mat `V'[1,1] = I(`k')
		est repost V = `V'
		local scalars : e(scalars)
		foreach s of local scalars {
			if e(`s')~=int(e(`s')) {
				est local `s'
			}
		}
		tsrevar `e(depvar)', list
		if "`r(varlist)'"~="" {
			foreach k of varlist `r(varlist)' {
				capture replace `k' = 0
			}
		}
		capture version `version':mfx compute `if' `in', `options' nose
		capture matrix `new' = e(Xmfx_`e(Xmfx_type)')  
		capture assert mreldif(`old',`new') < 1e-12
		if _rc {
			di as txt /*
*/ "Warning: predict() expression unsuitable for standard error calculation"
			di as txt /*
*/ "         option nose imposed" _n
			local failed failed
		}
	}
	restore
	est unhold `oldest'
	if "`failed'"~=""  {
		version `version':mfx compute `if' `in', `options' nose
		exit 
	}
	if _rc {
		exit _rc		
	}
	/* Otherwise, estimate standard errors */
	version `version':mfx compute `if' `in', `options' force
end

program define Display
* !! time series operator 
	args at dfdx se_dfdx level type title 
	tempname Z 
	local dummy "`e(Xmfx_dummy)'"
	local discret "`e(Xmfx_discrete)'"
	local c = colsof(`dfdx')
	if `level' < 10 | `level' > 99 {
		local level 95
	}
	scalar `Z' = invnorm(1-(1-`level'/100)/2)
        local 1 "variable"
        di in smcl in gr /*
                */ %8s abbrev(`"`1'"',8) " {c |}" _col(17) `"`title'"' /*
		*/ _col(26) /*
                */ `"Std. Err."' _col(40) `"z"' _col(45) `"P>|z|"' /*
                */ _col(52) `"[    `level'% C.I.   ]"'  /*
                */ _col(75) `"X"' _n /*
                */ "{hline 9}{c +}{hline 68}"

	local varlist : colnames(`dfdx')
	tokenize `varlist'
	local i 1
	while `i' <= `c' {
		local isdum : word `i' of `dummy'
		if `isdum' & ("`discret'" == "discrete") {
			local star "*"
			local anydum "true"
		}
		else local star " "
		local C = `dfdx'[1, `i']
                local s = `se_dfdx'[1, `i']
                local ll = `C' - `Z'*`s'
                local ul = `C' + `Z'*`s'
                local z  = `C'/`s'
		local x = `at'[1, `i']
						/* no effect */
		if `C' == 0 {
			di in smcl in gr /*
				*/ %8s abbrev(`"``i''"',8) `"`star'{c |} "' /*
				*/ "(no effect)" in ye _col(71)  /*
				*/ %8.6g `x'
		}	
		else {
                        di in smcl in gr %8s /*
			*/ abbrev(`"``i''"',8) `"`star'{c |}  "' in ye /*
                        */ %9.0g `C' `"   "'_c
			_sigfm 5 9 `s'
			if `s(code)' { dis in ye %9s "`s(output)'" `" "' _c }
                        else dis in ye %9.0g `s(output)' `" "' _c 
			di in ye /*
                        */ %7.2f `z'  `"  "' /*
                        */ %6.3f 2*normprob(-abs(`z')) `"  "' /*
                        */ %8.0g `ll' `" "' /*
                        */ %8.0g `ul' `"  "'    /*
                        */ %8.6g `x' 
                }
                local i=`i'+1
        }
        di in smcl in gr "{hline 9}{c BT}{hline 68}"
        if `"`anydum'"'==`"true"' {
                di in gr /*
                */ `"(*) `title'"' /*
                */ `" is for discrete change of dummy variable from 0 to 1"'
        }
end

program define Display2
	args at dfdx type title 
	local c = colsof(`dfdx')
	local dummy "`e(Xmfx_dummy)'"
	local discret "`e(Xmfx_discrete)'"
        local 1 "variable"
	di in smcl in gr /*
		*/ %32s abbrev(`"`1'"',32) " {c |}" _col(45) `"`title'"' /*
		*/ _col(67) `"X"' 
        di in smcl in gr "{hline 33}{c +}{hline 45}"
	local varlist : colnames(`dfdx')
        tokenize `varlist'
        local i 1
        while `i' <= `c' {
		local isdum : word `i' of `dummy'
                if `isdum' & ("`discret'" == "discrete") {
                        local star "*"
                        local anydum "true"
                }
		else local star " "
		local C= `dfdx'[1, `i']
		local x = `at'[1, `i']
                                                /* no effect */
                if `C' == 0 {
                        di in smcl in gr /*
			     */ %32s abbrev(`"``i''"',32) `"`star'{c |} "' /*
                             */ _col(42)"(no effect)" in ye _col(62) %8.6g `x'
                }
		else {
                        di in smcl in gr /*
			*/ %32s abbrev(`"``i''"',32) `"`star'{c |}  "'in ye /*
                        */ _col(42) %9.0g `C' `"   "' /*
			*/ _col(62) %8.6g `x' 
		}
		local i=`i'+1
	}
        di in smcl in gr "{hline 33}{c BT}{hline 45}"
        if `"`anydum'"'==`"true"' {
               di in gr /*
                */ `"(*) `title'"' /*
                */ `" is for discrete change of dummy variable from 0 to 1"'
        }
end
	
exit

syntax for compute
------------------

	mfx compute [if] [in] [, AT(string) EQlist(string) PREDict(string) 
	 	dydx eyex dyex eydx noDiscrete noEsample noWght noSe 
		Level(int $S_level) NONLinear ]


syntax for replay
-----------------

	mfx replay [, dydx eyex dyex eydx Level(int $S_level) ]

options
-------

 EQlist	:	specify which X's, default is all 
 AT	:	specify the eveluate point of X's, default mean
 PRED	:	specify f, for df/dx, default is the default predict
 dydx	:	calculate marginal effects
 eyex  	:	calculate elasticity
 dyex	:	calculate half elasticity (dy/ex)
 eydx	:	calculate half elasticity (ey/dx)
 noD	:	treat dummy variables as continuous ones
 noE	:	ignore e(sample)
 noW	:	ignore weights from the last estimate
 if in 	:	for the calculation of AT only
 noSe   : 	programmer's option, no std
 nonlinear:	if F(x,beta) is not of form F(xbeta)

method 
------

For the linear case:

F(X_1B_1, X_2B_2, ... X_mB_m)

		  dF         dF
M_ij 	     =	-------- = -------- * B_ij	 
	 	 dX_ij	   dX_iB_i


		  dM_ij  '	  dM_ij
Var(M_ij)    = 	--------  Var(B) -------
		   dB	           dB

 dM_ij		    ( dF )^ 2                         dF
-------      = ----------------- * B_ij * X_kl +  ---------- * I(i=k, j=l)
 dB_kl          dX_iB_i dX_kB_k                     dX_iB_i 

For the nonlinear case:

F(X, B)
		  dF
M_i 	     =  -------
		 dX_i 

 dM_i		 ( dF )^2
-------	     = 	----------- 
 dB_j   	 dX_idB_j


ados
----

_me_der		return	scalar	dF/dX_i 	if X_i is continous
_me_derd	return  scalar	dF/dX_i		if X_i is dummy
_me_derb	return 	scalar	dF/db_i
_me_der2	return  scalar  dF/dX_iB_j

_me_l_der	return  matrix	dF/dXB = (dF/dX_1B_1, ..., dF/dX_mB_m)
		call	_me_der if equation i is not constant only
		call 	_me_derb if equation i is constant only 

_me_l_der2	return 	matrix 	

				( d F )^2
			  --------------------
			        ( d^2 XB )  
