*! version 1.0.5  01feb2002 
*  original author -- Ken Heinecke, STB-20: ip6.
program def mkmat
	version 6
	syntax varlist(numeric) [if] [in] [, MATrix(string)]
	tempvar touse
	mark `touse' `if' `in'

	local dogen 0
	if "`matrix'"!="" {
		local matname "`matrix'"
		local dogen 1
	}
	preserve
	qui keep if `touse'
	if _N==0 {
		di "no observations"
		error 2000
	}
	tokenize `varlist'
	local i 1
	while "``i''"!="" {
		qui count if ``i'' == .
		if r(N)>0 {
			di in red "matrix ``i'' would have missing values"
			exit 504
		}
		local i = `i' + 1
	}
	local nvar = `i' - 1
	local nobs = _N
	if `dogen' {
		matrix `matname'=J(`nobs',`nvar',0) /* check matsize before  */
		mat drop `matname'		    /* we create any vectors */
	}
	tempname vnam
	while "`1'"!="" {
		if !`dogen' {
			local vnam "`1'"
		}
		mat `vnam'=J(`nobs',1,0)
		mat colnames `vnam' = `1'
		local i 1
		while (`i' <= `nobs') {
			mat `vnam'[`i',1] = `1'[`i']
			local i = `i' + 1
		}
		if `dogen' {
			matrix `matname'=nullmat(`matname'),`vnam'
		}
		mac shift
	}
end
