*! version 6.0.9  13nov2001 
program define ml_mlout
	version 6
	if "`e(cmd)'" == "" | "`e(opt)'"!="ml" { 
		error 301
	}
	syntax [, noHeader First EForm(string) Level(integer $S_level) /*
		*/ NEQ(integer -1) PLus ]
	if "`header'"=="" {
		di _n in gr `"`e(title)'"' /*
		*/ _col(51) in gr "Number of obs" _col(67) "= " /*
			*/ in ye %10.0g e(N)
		local cfmt=cond(e(chi2)<1e+7,"%10.2f","%10.3e")
		if "`e(chi2type)'"=="Wald" & e(chi2) == . {
			di in smcl _col(51) /* 
		*/ "{help j_robustsingular:Wald chi2(`e(df_m)'){col 67}= }" /*
			*/ in ye `cfmt' e(chi2)
		}
		else {
			di _col(51) in gr "`e(chi2type)' chi2(" /*
			*/ in ye "`e(df_m)'" in gr ")" _col(67) "= " /*
			*/ in ye `cfmt' e(chi2)
		}
		if e(r2_p)==. {
			di in gr "Log likelihood = " in ye %10.0g e(ll) /*
			*/ _col(51) in gr "Prob > chi2" _col(67) "= " /*
			*/ in ye %10.4f e(p)
		}
		else {
			di _col(51) in gr "Prob > chi2" _col(67) "= " /*
			*/ in ye %10.4f e(p)
			di in gr "Log likelihood = " in ye %10.0g e(ll) /*
			*/ _col(51) in gr "Pseudo R2" _col(67) "= " /*
			*/ in ye %10.4f e(r2_p)
		}
		di
	}
	if e(k_eq)==1 { 
		local first first
	}
	if "`eform'" != "" { 
		local eform eform(`eform')
	}

	/* Were there constraints ? */
	tempname cns
	capture mat `cns' = get(Cns)
	if !_rc {
		matrix dispCns
	}

	est di, `first' `eform' level(`level') neq(`neq') `plus'
	if e(rc)==504 { 
		di in red "Variance matrix missing because `e(user)' failed" /*
		*/ " to compute scores or computed" _n /*
		*/ "scores with missing values."
		exit 504
	}
	error `e(rc)'
end
exit
