*! version 6.1.1  24apr2001
program define mrdu0_, rclass
	version 6
	syntax [,  BHHH						 	/*
		*/ BHHHBfgs(numlist min=2 max=2 integer >=0 <99999)	/*
		*/ BHHHDfp(numlist min=2 max=2 integer >=0 <99999)	/*
		*/ BHHHQ BFGS DFP NR 					/*
		*/ NRBFGS(numlist min=2 max=2 integer >=0 <99999)	/*
		*/ Hessian Opg NATIVE ]

	local techniq = "`bhhh'`bhhhq'`bfgs'`dfp'`nr'"    +		/*
		*/ cond("`bhhhbfgs'"=="", "", "bhhhbfgs") +		/*
		*/ cond("`bhhhdfp'"=="", "", "bhhhdfp")   +		/*
		*/ cond("`nrbfgs'"=="", "", "nrbfgs")
	local vce "`hessian'`opg'`native'"
	if "`vce'"!="" & "`vce'"!="hessian" & "`vce'"!="opg" & /*
	*/ "`vce'"!="native" {
		di in red "hessian, opg, and native are mutually "	/*
			*/ "exclusive in technique()"
		exit 198
	}

				/* BEGIN common settings */
	return local method "rdu0"
	return local opt "ml_opt"
	return local evali "ml_e0i"		/* initialize numeric deltas */
	return local score "ml_bhhhs"		/* computes score  */
	return local vscore 1			/* scores computed by var */
	return local scvars "noscvars"		/* no scorevars for LL pgms */
				/* END common settings */


/*
	if "`techniq'"=="bhhh" { 
		return local eval "ml_ebhr0"	/* f, g, H evaulator */
		return scalar preserve = .
		if "`vce'"=="hessian" {
			return local evalf "ml_enrr0"   /* for final call */
		}
		exit
	}
*/

	if "`techniq'"=="bhhh" { 
		return local eval "ml_ebr0i"	/* f, g, H evaulator */
		return scalar preserve = .
		if "`vce'"=="hessian" {
			return local evalf "ml_enr0i"   /* for final call */
		}
		else	return local vce2 "OPG"
		exit
	}

	if "`techniq'"=="bhhhbfgs" { 
		return local eval "ml_ecr0i"	/* f, g, H evaulator */
		return scalar preserve = .
		tokenize `bhhhbfgs'
		return scalar ibhhh = `1'
		return scalar ibfgs = `2'
		if "`vce'"=="hessian" {
			return local evalf "ml_enr0i"   /* for final call */
		}
		else {
			return local evalf "ml_ebr0i"	/* for final call */
			return local vce2 "OPG"
		}
		exit
	}

	if "`techniq'"=="bhhhdfp" { 
		return local eval "ml_eer0i"	/* f, g, H evaulator */
		return scalar preserve = .
		tokenize `bhhhdfp'
		return scalar ibhhh = `1'
		return scalar idfp = `2'
		if "`vce'"=="hessian" {
			return local evalf "ml_enr0i"   /* for final call */
		}
		else {
			return local evalf "ml_ebr0i"	/* for final call */
			return local vce2 "OPG"
		}
		exit
	}

	if "`techniq'"=="nrbfgs" { 
		return local eval "ml_erdu0_nrbfgs"	/* f, g, H evaulator */
		return scalar preserve = .
		tokenize `nrbfgs'
		return scalar inr = `1'
		return scalar ibfgs = `2'
		if "`vce'"=="opg" {
			return local evalf "ml_ebr0i"	/* for final call */
			return local vce2 "OPG"
		}
		else if "`vce'"=="hessian" | "`vce'"==""  {	/* default */
			return local evalf "ml_enr0i"   /* for final call */
		}
		exit
	}

	if "`techniq'"=="bhhhq" { /* bhhh with "quick and dirty" derivatives */
		return local eval "ml_ebh0q"	/* f, g, H evaulator */
		return scalar preserve = .
		if "`vce'"=="hessian" {
			return local evalf "ml_enr0i"   /* for final call */
		}
		else	return local vce2 "OPG"
		exit
	}

/*
	if "`techniq'"=="bfgs" {
		return local eval "ml_ebfr0"  /* f, g, H evaulator */
		return local noinv "noInvert" /* (-H)^-1 returned by ml_edfr0 */
		return scalar preserve = .
		if "`vce'"=="opg" {
			return local evalf "ml_ebhr0"	/* for final call */
		}
		else if "`vce'"=="hessian" | "`vce'"==""  {	/* default */
			return local evalf "ml_enrr0"   /* for final call */
		}
		else if "`vce'"== "native" {
			return local evalf	/* no r(evalf) for native */
			return local noinf "noInvert" /* (-H)^-1 on final */
		}
		exit
	}
*/

	if "`techniq'"=="bfgs" {
		return local eval "ml_egr0i"  /* f, g, H evaulator */
		return local noinv "noInvert" /* (-H)^-1 returned by ml_edfr0 */
		return scalar preserve = .
		if "`vce'"=="opg" {
			return local evalf "ml_ebr0i"	/* for final call */
			return local vce2 "OPG"
		}
		else if "`vce'"=="hessian" | "`vce'"==""  {	/* default */
			return local evalf "ml_enr0i"   /* for final call */
		}
		else if "`vce'"== "native" {
			return local evalf	/* no r(evalf) for native */
			return local noinf "noInvert" /* (-H)^-1 on final */
			return local vce2 "BFGS"
		}
		exit
	}
/*

	if "`techniq'"=="dfp" {
		return local eval "ml_edfr0"  /* f, g, H evaulator */
		return local noinv "noInvert" /* (-H)^-1 returned by ml_edfr0 */
		return scalar preserve = .
		if "`vce'"=="opg" {
			return local evalf "ml_ebhr0"	/* for final call */
		}
		else if "`vce'"=="hessian" | "`vce'"==""  {	/* default */
			return local evalf "ml_enrr0"   /* for final call */
		}
		else if "`vce'"== "native" {
			return local evalf	/* no r(evalf) for native */
			return local noinf "noInvert" /* (-H)^-1 on final */
		}
		exit
	}
*/

	if "`techniq'"=="dfp" {
		return local eval "ml_edr0i"  /* f, g, H evaulator */
		return local noinv "noInvert" /* (-H)^-1 returned by ml_edfr0 */
		return scalar preserve = .
		if "`vce'"=="opg" {
			return local evalf "ml_ebr0i"	/* for final call */
			return local vce2 "OPG"
		}
		else if "`vce'"=="hessian" | "`vce'"==""  {	/* default */
			return local evalf "ml_enr0i"   /* for final call */
		}
		else if "`vce'"== "native" {
			return local evalf	/* no r(evalf) for native */
			return local noinf "noInvert" /* (-H)^-1 on final */
			return local vce2 "DFP"
		}
		exit
	}

/*
	if "`techniq'"=="nr" {
		return local eval "ml_enrr0"  /* f, g, H evaulator */
		return scalar preserve = .
		if "`vce'"=="opg" {
			return local evalf "ml_ebhr0"	/* for final call */
		}
		exit
	}
*/

	if "`techniq'"=="nr" {
		return local eval "ml_enr0i"  /* f, g, H evaulator */
		return scalar preserve = .
		if "`vce'"=="opg" {
			return local evalf "ml_ebr0i"	/* for final call */
			return local vce2 "OPG"
		}
		exit
	}

	di in red "technique(`tech') invalid"
	exit 198
end
exit

------------------------------------------------------------------------------

Settings for recursively defined, numeric derivatives techniques.

------------------------------------------------------------------------------

	Linear form

	Linear form equations no longer allowed.  Chain-rule derivatives 
	cannot be derived when the the L_i are not independent.  They could
	be used when the other equations are merely nonlinear and still
	produce independent L_i, but that does not seem worth the danger.

	Setup left in file, but commented out and the METHODi's renamed to
	be the only available calls.

	syntax [, BHHH BHHHQ BHHHI BFGS BFGSI DFP DFPI NR NRI 		/*
	      */  Hessian Opg NATIVE ]

	local techniq "`bhhh'`bhhhq'`bhhhi'`bfgs'`bfgsi'`dfp'`dfpi'`nr'`nri'"

