*! version 2.0.9  04oct2001
program define prtest, rclass byable(recall)
	version 6
	global S_1			/* will be n1	*/
	global S_2			/* will be p1	*/
	global S_3			/* will be n2	*/
	global S_4			/* will be p2	*/
	global S_6			/* will be z	*/

	/* turn "==" into "=" if needed before calling -syntax- */
	gettoken vn rest : 0, parse(" =")
	gettoken eq rest : rest, parse(" =")
	if "`eq'" == "==" {
		local 0 `vn' = `rest'
	}

	syntax varname [=/exp] [if] [in] [, /*
		*/ BY(varname) Level(integer $S_level) ]
	if `level' < 10 | `level' > 99 {
		di in red "level() invalid"
		exit 198
	}
	tempvar touse
	mark `touse' `if' `in'
	/* do not markout varname */

	if `"`exp'"'!="" { 
		if `"`by'"'!="" { 
			di in red `"may not combine = and by()"'
			exit 198
		}
		capture confirm number `exp'
		if _rc==0 {
			markout `touse' `varlist'
			cap assert `varlist'==1 | `varlist'==0 if `touse'
			if _rc {
				di in red `"`varlist' is not a 0/1 variable"'
				exit 450
			}
			cap assert `exp'<1 & `exp'>0 if `touse'
			if _rc {
				di in rd `"`exp' is not in (0,1)"'
				exit 450
			}
			qui summ `varlist' if `touse'
			local n1=r(N)
			local p1=r(mean)
			di 

			local xname = abbrev(`"`varlist'"',8)
			local c1 = 53 - length(`"`xname'"')

			di in gr `"One-sample test of proportion"' /*
			*/ _col(`c1') in ye `"`xname'"' in gr _col(53) /*
			*/ `": Number of obs = "' /*
			*/ in ye %8.0g `n1'

			local s = sqrt(`p1'*(1-`p1')/(`n1'))
			_ttest1 `varlist' `n1' `p1' `s' normal `level'

			BotLine
			di
                	local c1 = 27 - int((length(`"`xname'"'))/2)
                	di in gr _col(`c1') `"Ho: proportion("' /*
				*/ in ye `"`xname'"' /*
				*/ in gr `") = "' in ye `exp'
                	di
			local abname=abbrev("`varlist'", 8)
                	di in gr _col(6) `"Ha: `abname' < "' /*
			*/ in ye `exp' in gr /*
                	*/ _col(30) `"Ha: `abname' ~= "' in ye `exp' in gr  /*
                	*/ _col(56) `"Ha: `abname' > "' in ye `exp' 
			local abname

			ret scalar z = (`p1'-`exp')/sqrt(`exp'*(1-`exp')/`n1')

                	di in gr _col(11) `"z = "' in ye %6.3f `return(z)' /*
                	*/ in gr _col(36) `"z = "' in ye %6.3f `return(z)'  /*
                	*/ in gr _col(61) `"z = "' in ye %6.3f `return(z)' 

			local pp2 = 2*normprob(-abs(`return(z)'))
			if `return(z)' < 0 {
				local pp1 = `pp2'/2
				local pp3 = 1 - `pp1'
			}
			else {
				local pp3 = `pp2'/2
				local pp1 = 1 - `pp3'
			}

                	di in gr _col(7) `"P < z = "' in ye %6.4f `pp1' /*
                	*/ in gr _col(30) `"P > |z| = "' in ye %6.4f `pp2' /*
                	*/ in gr _col(57) `"P > z = "' in ye %6.4f `pp3'

			ret scalar N_1 = `n1'
			ret scalar P_1 = `p1'

			/* Double saves */
			global S_1 "`return(N_1)'"
			global S_2 "`return(P_1)'"
			global S_6 "`return(z)'"

			exit
		}
		cap assert `varlist'==1 | `varlist'==0 if `touse' & `varlist'!=.
		if _rc {
			di in red `"`varlist' is not a 0/1 variable"'
			exit 450
		}
		cap assert (`exp')==1 | (`exp')==0 if `touse' & (`exp')!=.
		if _rc {
			di in red `"`exp' is not a 0/1 variable"'
			exit 450
		}
		unab exp : `exp', max(1)
		quietly sum `varlist' if `touse'
		local n1=r(N)
		local p1=r(mean)
		quietly sum `exp' if `touse'
		local n2=r(N)
		local p2=r(mean)
		* local abnam1 = abbrev("`varlist'",8)
		* local abnam2 = abbrev("`exp'",8)
		prtesti `n1' `p1' `n2' `p2', xname(`varlist') yname(`exp') /*
			*/ level(`level')

		ret add
		exit
	}
	confirm var `by'
	quietly tab `by' if `touse'
	if r(r)!=2 { 
		di in red `"`by' takes on "' r(r) `" values, not 2"'
		exit 450
	}
	qui summ `by' if `touse'
	local g1 = r(min)
	local g2 = r(max)
	
	quietly sum `varlist' if `by'==`g1' & `touse'
	local n1 = r(N)
	local p1 = r(mean)
	quietly sum `varlist' if `by'==`g2' & `touse'
	local n2 = r(N)
	local p2 = r(mean)

        local vlab : value label `by'
        local xname = `g1'
        local yname = `g2'
        if `"`vlab'"' != `""' {
                local xname : label `vlab' `g1'
                if `"`xname'"' == `""' {
                        local xname = `g1'
                }
                local yname : label `vlab' `g2'
                if `"`yname'"' == `""' {
                        local yname = `g2'
                }
        }
	prtesti `n1' `p1' `n2' `p2', /*
				*/ xname(`xname') yname(`yname') level(`level')

	ret add
end

program define BotLine
	di in smcl in gr "{hline 9}{c BT}{hline 68}"
end
