*! version 1.0.8  01jun2001
program define statsby
	version 7
	gettoken cmd 0: 0
	if `"`cmd'"' == `""' { error 198 }

	local k 0
	_getxel first _stat `0'
	while `s(found)' {
		local k = `k' + 1
		local name1_`k' `"`s(name)'"'
		local exp1_`k' `"`s(exp)'"'
		local eexp1_`k' `"`s(eexp)'"'
		local 0 `s(rest)'
		_getxel second _stat `0'
	}
	syntax [, BY(varlist) Total Subsets CLEAR REPLACE Double]

	qui des, short
	if r(changed) & ("`clear'" == "") & ("`replace'" == "" ) {
		error 4
	}

	qui `cmd'
					/* get full stat list */
	local ii 1
	forvalues i = 1(1)`k' {
		if `"`eexp1_`i''"' != `""' {
			_getxel2 `eexp1_`i''
			tokenize `eexp1_`i''
			local type `1'
			local eq `2'
			tempname B
			mat `B' = e(b)
			if "`eq'" != "" {
				mat `B' = `B'[1,"`eq':"]
			}
			local cnames : colnames `B'
			local c1 : word 1 of `cnames'
			local n `s(n)'
			if "`type'" == "_b" {
				local name`ii'= substr("b_`c1'",1,32)
			}
			else local name`ii' = substr("se_`c1'",1,32)
			local exp`ii' `"`s(e1)'"'
			local ii = `ii' + 1
			local temp `c1'
			forvalues j = 2(1)`n' {
				local cj : word `j' of `cnames'
				local cj5 = substr("`cj'", 1,29)
				local junk : subinstr local temp "`cj5'" /*
				*/ "`cj5'", all count(local m)
				local temp `temp' `cj'
				if substr("`cj'",1,1)=="_" {
					local cj = substr("`cj'",2,.)
				}
				if `m' == 0  {
					if "`type'" == "_b" {
					local name`ii' = substr("b_`cj'", 1,32)
					}
					else {
					local name`ii' = substr("se_`cj'", 1,32)
					}
				}
				else {
					if "`type'" == "_b" {
					local name`ii' = substr("b_`m'`cj'",1,32)
					}
					else {
					local name`ii' =substr("se_`m'`cj'",1,32)
					}
				}
				local exp`ii' `"`s(e`j')'"'
				local ii = `ii' + 1
			}
		}
		else {
                        local name`ii' `name1_`i''
                        local exp`ii' `exp1_`i''
                        local ii = `ii' + 1
		}
	}
	local k = `ii'-1
	/* check for empty expression list */
	if `k' < 1 {
		di as error "empty exp_list"
		exit 198
	}
	dis as txt _n `"command:     `cmd'"'
	dis as txt    `"by:          `by'"'
	dis as txt    `"statistics:  `name1' = `exp1'"'
	local names `name1'
	local exps (`exp1')
	local i 2
	while `i' < = `k' {
		local names `names' `name`i''
		local exps `exps' (`exp`i'')
		dis as txt _col(14) `"`name`i'' = `exp`i''"'
		local i = `i' + 1
	}

	tempname memhold
	tempfile results
	postfile `memhold' `by' `names' using `"`results'"', `double'

	local by0 `by'
	if "`subsets'" != "subsets" {
		Post0	`"`cmd'"' `"`by'"' `"`exps'"' `"`names'"' /*
			*/ `"`by0'"' `memhold' `"`results'"' `total'
	}
	else {
		Post1	`"`cmd'"' `"`by'"' `"`exps'"' `"`names'"' /*
			*/ `memhold' `"`results'"'
	}
	if "`by'" != "" {
		tokenize `by'
		local j = 1
		while "``j''" != "" {
			local lb`j' : value label ``j''
		        if "`lb`j''" != "" {
				tempfile f`j'
				qui label save `lb`j'' using `"`f`j''"'
			}
			local j = `j' + 1
		}
	}
	postclose `memhold'
	qui use `"`results'"', clear
	if "`by'" ! = "" {
		sort `by'
		tokenize `by'
		local j = 1
		while "``j''" != "" {
			if `"`f`j''"' != "" {
				qui run `"`f`j''"'
				label val ``j'' `lb`j''
			}
			local j = `j' + 1
		}
	}
	global S_FN
	global S_FNDATE
end

program define Post0
	args	cmd	/* command
	*/  	by	/* by list for post
	*/	exps	/* statistics
	*/	names	/* names
	*/	by0	/* by list for cmd
	*/	memhold /*
	*/ 	results /*
	*/	total

	if `"`by'"' == "" | `"`by0'"' == "" {
		qui `cmd'
		version 6: post `memhold' `by' `exps'
	}
	else {
	 	if "`total'" == "total" {
			tokenize `by'
			while `"`1'"' != "" {
				local by1 `by1' (.)
				mac shift
			}
			qui `cmd'
			version 6: post `memhold' `by1' `exps'
		}
						/* groups */
		sort `by0'
		tempvar group
		qui egen `group' = group( `by0' )
		local i = _N
		while (`i' > = 1) & (`group'[`i'] == .) {
			local i = `i' - 1
		}

		local ngrp = `group'[`i']
		local i 1
		while `i' < = `ngrp'{
			preserve
			cap {
				qui keep if `group' == `i'
				qui `cmd'
				version 6: post `memhold' `by' `exps'
			}
			restore
			local i = `i' + 1
		}
	}
end

program define Post1
	args	cmd	/* command
	*/  	by	/* by list for post
	*/	exps	/* statistics
	*/	names	/* names
	*/	memhold /*
	*/ 	results

	local bynum : word count `by'
	tempname M
	GetMat `bynum' `M'
	local rnum = 2^`bynum'
	local i = 1
	while `i' <= `rnum' {
		tokenize `by'
		preserve
		cap noi {
			local j 1
			local by0
			while `j' <= `bynum'{
				if `M'[`i',`j'] {
					local by0  `by0' ``j''
 				}
				else qui replace ``j'' = .
				local j = `j' + 1
			}
			Post0	`"`cmd'"' `"`by'"' `"`exps'"' `"`names'"' /*
			*/ `"`by0'"' `memhold' `"`results'"'
		}
		restore
		local i = `i' + 1
	}
end

program define GetMat
	args bynum	M
	local rnum = 2^`bynum'
	mat `M' = J(`rnum', `bynum',0)
	local i 0
	while `i' <= `rnum'-1 {
		local j = `bynum'
		local a `i'
		while `j' > = 1 {
			if `a' == 0 {
				local j = 0
			}
			else {
				local b  mod(`a', 2)
				local a  int(`a'/2)
				mat `M'[`i'+1,`j'] = `b'
				local j = `j' - 1
			}
		}
		local i = `i' + 1
	}
end
