*! version 2.1.1  02oct2001
program define testnl /* equation names [, g(matname) r(matname)] */, rclass
	version 7

	tempname R G b V oldest
	matrix `b' = e(b)	/* last estimates not found possible */
	local k = colsof(`b')
	
	di
	local nc 0
	if _caller() < 6 {
		gettoken tok 0 : 0, parse(" ,")
		while "`tok'" != "" & "`tok'"!="," {
			eq ?? `tok'
			local tok `r(eq)'
			local eqtns `"`eqtns' `"`tok'"'"'
			local nc = `nc' + 1
			*di as txt "  (`nc')" _col(8) as res `"`tok'"'
			gettoken tok 0 : 0, parse(" ,")
		}
	}
	else {
		gettoken tok : 0, parse(" (,")
		if `"`tok'"' == "(" {
			while `"`tok'"' == "(" { 
				local nc = `nc' + 1
				gettoken tok 0 : 0, parse(" (,") match(paren)
				*di as txt "  (`nc')" _col(8) as res `"`tok'"'
				local eqtns `"`eqtns' `"`tok'"'"'
				gettoken tok : 0, parse(" (,")
			}
			if `"`tok'"' != "," & `"`tok'"' != "" { 
				error 198
			}
		}
		else {
			gettoken tok 0 : 0, parse(" ,")
			while `"`tok'"' != "" & `"`tok'"' != "," {
				local nc 1
				local eq `eq' `tok'
				gettoken tok 0 : 0, parse(" ,")
			}
			if `nc'==0 { error 198 }
			*di as txt "  (1)" _col(8) as res `"`eq'"'
			local eqtns `" `"`eq'"'"'
			local eq
		}
	}
	if `"`tok'"' == "," {
		local 0 `", `0'"'
		syntax [, G(string) R(string)]
	}

	* translate  eq1=eq2=eq3  syntax style into  eq1=eq2  eq1=eq3 etc
	ExpandEqns `eqtns'
	local eqtns `"`r(eqtns)'"'
	local nc    `r(neq)' 
		
	DisplayEqns `eqtns' 
	
	mat `R' = J(`nc',1,0)
	MakeR `R' = `eqtns'

	if "`r'"!="" { 
		mat `r' = `R'		/* wwg: do we want to return this? */
	}

	mat `G' = J(`nc', `k', 0)
	mat `V' = e(V)

	nobreak {
		estimates hold `oldest'
		est post `b' `V'		/* results we can modify */
		capture noisily break MakeG `G' = `R' `eqtns'
		local rc = _rc
		estimates unhold `oldest'
	}
	if `rc' { exit `rc' }

				/* V = inv(GVG') */
	mat `V' = `G' * e(V) * `G''
	mat `V' = syminv(0.5*(`V' + `V''))

	local rnc `nc'
	forv i = 1/`nc' { 
		if `V'[`i',`i'] == 0 { 
			di as txt _col(8) "Constraint (`i') dropped"
			local rnc = `rnc' - 1
		}
	}

				/* V = R'VR */
	mat `V' = `R'' * `V' * `R'
	mat `V' = 0.5*(`V' + `V'')
	if "`g'" != "" {
		mat `g' = `G'
	}

	di
	Denomdof
	return scalar df_r = r(df_r)

	if return(df_r)==. {
		local skip = max(16-length("`rnc'"),0)
		di as txt _skip(`skip') "chi2(`rnc') =" /*
		*/ as res %12.2f `V'[1,1]
		di as txt _col(12) "Prob > chi2 =  " /*
		*/ as res %12.4f chi2tail(`rnc',`V'[1,1])

		ret scalar chi2 = `V'[1,1]
		ret scalar df = `rnc'
		global S_6 = return(chi2)		/* double saves */
	}
	else {
		local skip = max(18-length("`rnc' `return(df_r)'"),0)
		di as txt _skip(`skip') "F(`rnc', `return(df_r)') =" /*
		*/ as res %12.2f `V'[1,1]/`rnc'
		di as txt _col(15) "Prob > F =  " /* 
		*/ as res %12.4f fprob(`rnc',return(df_r),`V'[1,1]/`rnc')

		ret scalar F = `V'[1,1]/`rnc'
		ret scalar df = `rnc'
		global S_6 = return(F)			/* double saves */
	}
	global S_3 `return(df)'		/* double saves */
	global S_5 `return(df_r)'	/* double saves */
end


program define MakeR /* R = quoted_eqtn_list */
	local R "`1'"
	mac shift 2
	tempname w1 w2
	local i 1
	while "``i''" != "" {
		Fixeq `i' ``i''
		local eq `r(eq)'
		scalar `w1' = `eq'
		if `w1' == . {
			di as err "equation (`i') evaluates to missing"
			exit 498
		}
		if _N > 1 {
			scalar `w2' = `eq' in 2
			if `w1' != `w2' {
				di as err /*
				*/ "equation (`i') contains reference to X rather than _b[X]"
				exit 198
			}
		}	
		mat `R'[`i',1] = `w1'
		local i=`i'+1
	}
end


program define MakeG /* G = R quoted_equation_list */
	local G "`1'"
	/* = */
	local R "`3'"
	mac shift 3

	tempname b
	mat `b' = e(b)

	local i 1
	while "``i''" != "" {
		Fixeq `i' ``i''
		local eq `r(eq)'
		local j 1
		while `j' <= colsof(`b') {
			Deriv `G' `i' `j' = "`eq'" `b' `R' 
			local j = `j'+1
		}
		local i = `i'+1
	}
end


program define Deriv /* G i j = equation b R */
	local G "`1'"
	local i  `2'
	local j  `3' 
	/* = */
	local eq "`5'"
	local b   `6'
	local R   `7'

	tempname origb
	scalar `origb' = `b'[1,`j']
	Post `b' `j' "abs(`b'[1,`j'])*.01+.01" 
	if (`eq') == `R'[`i',1] { exit }	/* deriv is zero */

	tempname db w w2 goal0 goal1 r0

	scalar `db' = abs(`b'[1,`j'])*.01 + .01
	scalar `w' = `eq'
	scalar `r0' = `R'[`i',1]

	scalar `goal0' = abs(`r0')*1e-6 + 1e-6
	scalar `goal1' = abs(`r0')*1e-5 + 1e-5

	while abs(`w'-`r0') < `goal0' | abs(`w'-`r0') > `goal1' {
 		scalar `db' = ((`goal0'+`goal1')/2)*`db'/abs(`w'-`r0')
		if `db' < . { Post `b' `j' `db' }
		else {				/* deriv is essentially zero */
			local name : colfullnames `b'
			local name : word `j' of `name'
			di as txt _col(8) /*
*/ "warning: derivative with respect to `name' coefficient is near zero,"
			di as txt _col(8) /*
*/ "         derivative treated as zero"
			Post `b' `j' (`origb'-`b'[1,`j'])
			exit
		}
		scalar `w' = `eq'
	}
	
	Post `b' `j' -`db'
	scalar `w2' = `eq'
	mat `G'[`i',`j'] = (`w' - `w2') / (2*`db')
end


program define Post /* b j deltab */
	tempname b2 v2
	mat `b2' = `1'
	mat `b2'[1,`2'] = `1'[1,`2'] + (`3')
	mat `v2' = e(V)
	est post `b2' `v2'
end


program define Fixeq /* # unquoted_equation */, rclass
	gettoken eqno 0 : 0
	tokenize `0', parse("=")
	local neq 0
	while "`1'" != "" {
		if "`1'" == "=" | "`1'" == "==" {
			local neq = `neq' + 1
			if `neq' > 1 { 
				di as err /*
				*/ "equation (`eqno') has too many = signs"
				exit 198
			}
			local res "`res'-("
		}
		else	local res "`res'`1'"
		mac shift
	}
	if `neq' == 0 { 
		di as err "equation (`eqno') has no = sign"
		exit 198
	}
	return local eq "`res')"
end


program define Denomdof, rclass
	if "`e(cmd)'" != "" { 
		return scalar df_r = e(df_r) 
		exit
	}
	capture est di
	if _rc == 0 {
		return scalar df_r = _result(5) 	/* leave as is, old */
		exit
	}
	return scalar df_r = . 
end


program define ExpandEqns, rclass
	local eqlist
	local neq 0
	local i 1
	while "``i''" != "" {
		SplitEq `i' ``i''
		local ni `r(neq)'
		local neq = `neq' + `ni'
		forv j = 1/`ni' {
			local eqlist `"`eqlist' `"`r(eq`j')'"'"'
		}
		local i = `i'+ 1
	}
	return local neq   `neq'
	return local eqtns `"`eqlist'"'
end	


program define SplitEq, rclass
	gettoken eqno 0 : 0
	tokenize `0', parse("=")
	local neq -1
	while "`1'" != "" {
		if "`1'" == "=" | "`1'" == "==" {
			local neq = `neq' + 1
			if `neq' == 0 {
				local lhs `res'
				local res	
			}
			else {
				return local eq`neq' "`lhs' = `res'"
				local res
			}	
		}	
		else	local res "`res'`1'"
		mac shift
	}
	if `neq' == -1 {
		di as err "equation (`eqno') has no = sign"
		exit 198
	}	
	if "`res'" == "" {
		di as err "correct format is exp1 = exp2 [= exp3 ..]"
		exit 198
	}	
	else {
		local neq = `neq' + 1
		return local eq`neq' "`lhs' = `res'"
	}
	return local neq `neq'
end		

program define DisplayEqns
	local i 1
	while `"`1'"' != "" {
		di _col(3) as txt "(`i')" as res `"{col 8}{bind:`1'}"'
		local i = `i'+1
		mac shift
	}
end	

exit

Internal documentation

The Wald-test formula is (Green, 336)

                         -1
      W = (R(b)-q)'[GVG']  (R(b)-q)

where G is the derivative matrix of R(b) with respect to b.
