*! version 2.3.2  12mar2001
program define xpose
	version 7.0
	syntax [, CLEAR Format(string) Format1 PROMote Varname ]
	if "`clear'"=="" {
		di as err "you must specify ', clear'"
		exit 198
	}
	if "`format'"!="" & "`format1'"!="" {
		di as err "format() and format are mutually exclusive"
		exit 198
	}
	if (_N==0) { error 2000 }
	quietly describe
	if r(k)==0 {
		di as txt "(no variables)"
		exit 2000
	}
	capture confirm var _varname
	if _rc == 0 {
		local i = 1
		while (`i' <= r(N)) {
			local vn = _varname[`i']
			local vns "`vns' `vn'"
			local i = `i' + 1
		}
	}
	preserve
	tempfile tempfi
	quietly {
		capture drop _varname
		describe
		if r(N)==1 {
			local vr "v1"
		}
		else 	local vr = "v1-v" + string(r(N))
		local bv = r(k)
		if "`varname'"!="" {
			local 0 "_all"
			syntax varlist
		}
		noisily outfile using `"`tempfi'"', nolabel
		if "`format1'"!="" {
			unab vars : _all
			local fmtmax 0
			foreach var of local vars {
				local fmthold : format `var'
				if index("`fmthold'", "s")==0 & index("`fmthold'", "d")==0 /*
					*/ & index("`fmthold'", "D")==0 /*
					*/ & index("`fmthold'", "m")==0 /*
					*/ & index("`fmthold'", "M")==0 /*
					*/ & index("`fmthold'", "y")==0 /*
					*/ & index("`fmthold'", "Y")==0 {
					if index("`fmthold'", "-")!=0 {
						local fmthold = subinstr("`fmthold'", "-", "", .)
					}
					local fmthold = substr("`fmthold'", 2, 2)
					local fmthold = subinstr("`fmthold'", ".", "", .)
					if `fmtmax' < `fmthold' {
						local fmtmax = `fmthold'
						local fmt : format `var'
					}
				}
			}
		}
		else {
			if "`format'"!="" {
				local fmt = "`format'"
			}
		}
		if "`promote'"!="" {
			local bytetype 0
			local inttype 0
			local longtype 0
			local floattype 0
			local doubletype 0
			unab vars : _all
			foreach var of local vars {
				local type : type `var'
				if index("`type'", "str")==0 {
					if "`type'"=="double" {
						local doubletype 1
					}
					else if "`type'"=="float" {
						local floattype 1
					}
					else if "`type'"=="long" {
						local longtype 1
					}
					else if "`type'"=="int" {
						local inttype 1
					}
					else if "`type'"=="byte" {
						local bytetype 1
					}
				}
			}
			if `doubletype' {
				local newtype "double"
			}
			else if `floattype' & `longtype' {
				local newtype "double"
			}
			else if `floattype' & !`longtype' {
				local newtype "float"
			}
			else if `longtype' {
				local newtype "long"
			}
			else if `inttype' {
				local newtype "int"
			}
			else if `bytetype' {
				local newtype "byte"
			}

/* next if added to handle all string dataset */
			if "`newtype'"!="" {
				local vr = "`newtype'(`vr')"
			}
		}
		drop _all
		infile `vr' using `"`tempfi'"', byvariable(`bv')
		if "`vns'"!="" {
			tokenize `vns'
			local i 1
			while "`1'"!="" {
				rename v`i' `1'
				mac shift
				local i = `i' + 1
			}
		}
		if ("`format1'"!="" | "`format'"!="") & "`fmt'"!="" {
			format _all `fmt'
		}
		if "`varname'"!="" {
			gen str8 _varname=""
			local i 1
			tokenize `varlist'
			while "`1'"!="" {
				replace _varname = "`1'" in `i'
				local i = `i' + 1
				mac shift
			}
		}
		restore, not
	}
end
